<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76981 "21:23:01"))'</do-it>



<class>
<name>ChemoJunAtomConnection</name>
<environment>ChemoJun</environment>
<super>Jun.JunAbstractObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>fromAtom toAtom bondType stereoType attributeTable </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Basic-Objects</category>
<attributes>
<package>ChemoJun-Basic-Objects</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunAtomConnection class</class-id> <category>instance creation</category>

<body package="ChemoJun-Basic-Objects" selector="fromAtom:toAtom:">fromAtom: fromAtomObject toAtom: toAtomObject 
	| atomConnection |
	atomConnection := self new.
	atomConnection fromAtom: fromAtomObject.
	atomConnection toAtom: toAtomObject.
	^atomConnection</body>

<body package="ChemoJun-Basic-Objects" selector="fromAtom:toAtom:bondType:">fromAtom: fromAtomObject toAtom: toAtomObject bondType: bondType 
	| atomConnection |
	atomConnection := self new.
	atomConnection fromAtom: fromAtomObject.
	atomConnection toAtom: toAtomObject.
	atomConnection bondType: bondType.
	^atomConnection</body>

<body package="ChemoJun-Basic-Objects" selector="fromAtom:toAtom:bondType:stereoType:">fromAtom: fromAtomObject toAtom: toAtomObject bondType: bondType stereoType: stereoType 
	| atomConnection |
	atomConnection := self new.
	atomConnection fromAtom: fromAtomObject.
	atomConnection toAtom: toAtomObject.
	atomConnection bondType: bondType.
	atomConnection stereoType: stereoType.
	^atomConnection</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection class</class-id> <category>copyright</category>

<body package="ChemoJun-Basic-Objects" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Basic-Objects" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Basic-Objects" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection class</class-id> <category>defaults</category>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomObjectClass">defaultAtomObjectClass
	^self defaultMoleculeObjectClass defaultAtomObjectClass</body>

<body package="ChemoJun-Basic-Objects" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^ChemoJunMoleculeObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection class</class-id> <category>examples</category>

<body package="ChemoJun-Basic-Objects" selector="example1">example1
	"ChemoJunAtomConnection example1."

	| atomConnection |
	atomConnection := ChemoJunAtomConnection new.
	^atomConnection</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id> <category>initialize-release</category>

<body package="ChemoJun-Basic-Objects" selector="initialize">initialize
	super initialize.
	fromAtom := nil.
	toAtom := nil.
	bondType := nil.
	stereoType := nil.
	attributeTable := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id> <category>accessing</category>

<body package="ChemoJun-Basic-Objects" selector="bondType">bondType
	bondType isNil ifTrue: [bondType := self defaultBondType].
	^bondType</body>

<body package="ChemoJun-Basic-Objects" selector="bondType:">bondType: aNumber 
	aNumber isNil 
		ifTrue: [bondType := self defaultBondType]
		ifFalse: [bondType := aNumber]</body>

<body package="ChemoJun-Basic-Objects" selector="bondTypeSymbol">bondTypeSymbol
	self bondType = 1 ifTrue: [^#single].
	self bondType = 2 ifTrue: [^#double].
	self bondType = 3 ifTrue: [^#triple].
	self bondType = 4 ifTrue: [^#aromatic].
	self bondType = 5 ifTrue: [^#singleORdouble].
	self bondType = 6 ifTrue: [^#singleORaromatic].
	self bondType = 7 ifTrue: [^#doubeORaromatic].
	self bondType = 8 ifTrue: [^#any].
	^#unknown</body>

<body package="ChemoJun-Basic-Objects" selector="fromAtom">fromAtom
	fromAtom isNil ifTrue: [fromAtom := self defaultFromAtom].
	^fromAtom</body>

<body package="ChemoJun-Basic-Objects" selector="fromAtom:">fromAtom: atomObject 
	atomObject isNil
		ifTrue: [fromAtom := self defaultFromAtom]
		ifFalse: [fromAtom := atomObject]</body>

<body package="ChemoJun-Basic-Objects" selector="length">length
	^(self fromAtom atomicPoint to: self toAtom atomicPoint) length</body>

<body package="ChemoJun-Basic-Objects" selector="stereoType">stereoType
	stereoType isNil ifTrue: [stereoType := self defaultStereoType].
	^stereoType</body>

<body package="ChemoJun-Basic-Objects" selector="stereoType:">stereoType: aNumber 
	aNumber isNil 
		ifTrue: [stereoType := self defaultBondType]
		ifFalse: [stereoType := aNumber]</body>

<body package="ChemoJun-Basic-Objects" selector="stereoTypeSymbol">stereoTypeSymbol
	self stereoType = 0 ifTrue: [^#none].
	self stereoType = 1 ifTrue: [^#up].
	self stereoType = 4 ifTrue: [^#either].
	self stereoType = 6 ifTrue: [^#down].
	^#unknown</body>

<body package="ChemoJun-Basic-Objects" selector="toAtom">toAtom
	toAtom isNil ifTrue: [toAtom := self defaultToAtom].
	^toAtom</body>

<body package="ChemoJun-Basic-Objects" selector="toAtom:">toAtom: atomObject 
	atomObject isNil
		ifTrue: [toAtom := self defaultToAtom]
		ifFalse: [toAtom := atomObject]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id> <category>attribute accessing</category>

<body package="ChemoJun-Basic-Objects" selector="attributeTable">attributeTable
	attributeTable isNil ifTrue: [attributeTable := JunAttributeTable new].
	^attributeTable</body>

<body package="ChemoJun-Basic-Objects" selector="connectionColor">connectionColor
	^self attributeTable at: #connectionColor
		ifAbsent: [self defaultConnectionColor]</body>

<body package="ChemoJun-Basic-Objects" selector="connectionColor:">connectionColor: colorValue 
	colorValue ifNil: [self attributeTable removeKey: #connectionColor]
		ifNotNil: [:it | self attributeTable at: #connectionColor put: it]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id> <category>copying</category>

<body package="ChemoJun-Basic-Objects" selector="postCopy">postCopy
	super postCopy.
	attributeTable := attributeTable copy

	"You must copy fromAtom and toAtom."</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id> <category>defaults</category>

<body package="ChemoJun-Basic-Objects" selector="defaultBondType">defaultBondType
	^1</body>

<body package="ChemoJun-Basic-Objects" selector="defaultConnectionColor">defaultConnectionColor
	^ColorValue veryDarkGray</body>

<body package="ChemoJun-Basic-Objects" selector="defaultFromAtom">defaultFromAtom
	^self class defaultAtomObjectClass new</body>

<body package="ChemoJun-Basic-Objects" selector="defaultStereoType">defaultStereoType
	^0</body>

<body package="ChemoJun-Basic-Objects" selector="defaultToAtom">defaultToAtom
	^self class defaultAtomObjectClass new</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id> <category>printing</category>

<body package="ChemoJun-Basic-Objects" selector="printOn:">printOn: aStream 
	aStream nextPutAll: '('.
	aStream nextPutAll: self fromAtom printString.
	aStream space.
	aStream nextPutAll: self toAtom printString.
	aStream space.
	aStream nextPutAll: self bondTypeSymbol printString.
	aStream space.
	aStream nextPutAll: self stereoTypeSymbol printString.
	aStream nextPutAll: ')'</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomConnection</class-id> <category>testing</category>

<body package="ChemoJun-Basic-Objects" selector="hasConnectionColor">hasConnectionColor
	^self attributeTable includesKey: #connectionColor</body>

<body package="ChemoJun-Basic-Objects" selector="isAny">isAny
	^self bondType = 8</body>

<body package="ChemoJun-Basic-Objects" selector="isAromatic">isAromatic
	^self bondType = 4</body>

<body package="ChemoJun-Basic-Objects" selector="isDouble">isDouble
	^self bondType = 2</body>

<body package="ChemoJun-Basic-Objects" selector="isDoubleOrAromatic">isDoubleOrAromatic
	^self bondType = 7</body>

<body package="ChemoJun-Basic-Objects" selector="isSingle">isSingle
	^self bondType = 1</body>

<body package="ChemoJun-Basic-Objects" selector="isSingleOrAromatic">isSingleOrAromatic
	^self bondType = 6</body>

<body package="ChemoJun-Basic-Objects" selector="isSingleOrDouble">isSingleOrDouble
	^self bondType = 5</body>

<body package="ChemoJun-Basic-Objects" selector="isTriple">isTriple
	^self bondType = 3</body>
</methods>


</st-source>
