<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76981 "21:23:01"))'</do-it>



<class>
<name>ChemoJunAtomObject</name>
<environment>ChemoJun</environment>
<super>Jun.JunAbstractObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>atomicSymbol atomicPoint atomicRadius atomicBody areaCoefficient attributeTable </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Basic-Objects</category>
<attributes>
<package>ChemoJun-Basic-Objects</package>
</attributes>
</class>

<shared-variable>
<name>AtomicColors</name>
<environment>ChemoJun.ChemoJunAtomObject</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>ChemoJun-Basic-Objects</package>
</attributes>
</shared-variable>

<shared-variable>
<name>AtomicBonds</name>
<environment>ChemoJun.ChemoJunAtomObject</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>ChemoJun-Basic-Objects</package>
</attributes>
</shared-variable>

<shared-variable>
<name>VanDerWaalsRadii</name>
<environment>ChemoJun.ChemoJunAtomObject</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>ChemoJun-Basic-Objects</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunAtomObject class</class-id> <category>class initialization</category>

<body package="ChemoJun-Basic-Objects" selector="initialize">initialize
	"ChemoJunAtomObject initialize."

	self flushConstants</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject class</class-id> <category>instance creation</category>

<body package="ChemoJun-Basic-Objects" selector="atomicSymbol:atomicPoint:">atomicSymbol: aString atomicPoint: aPoint 
	| aNumber |
	aNumber := self vanDerWaalsRadiusAt: aString.
	^self 
		atomicSymbol: aString
		atomicPoint: aPoint
		atomicRadius: aNumber</body>

<body package="ChemoJun-Basic-Objects" selector="atomicSymbol:atomicPoint:atomicRadius:">atomicSymbol: aString atomicPoint: aPoint atomicRadius: aNumber 
	| atomicObject |
	atomicObject := self new.
	atomicObject atomicSymbol: aString.
	atomicObject atomicPoint: aPoint.
	atomicObject atomicRadius: aNumber.
	^atomicObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject class</class-id> <category>constants</category>

<body package="ChemoJun-Basic-Objects" selector="atomicBonds">atomicBonds
	"ChemoJunAtomObject atomicBonds."

	"ChemoJunAtomObject flushConstants."

	| aDictionary |
	AtomicBonds isNil 
		ifTrue: 
			[aDictionary := Dictionary new.
			aDictionary at: 'H' put: 1.
			aDictionary at: 'He' put: 0.
			aDictionary at: 'Li' put: 1.
			aDictionary at: 'Be' put: 2.
			aDictionary at: 'B' put: 3.
			aDictionary at: 'C' put: 4.
			aDictionary at: 'N' put: 3.
			aDictionary at: 'O' put: 2.
			aDictionary at: 'F' put: 1.
			aDictionary at: 'Ne' put: 0.
			aDictionary at: 'Na' put: 1.
			aDictionary at: 'Mg' put: 2.
			aDictionary at: 'Al' put: 3.
			aDictionary at: 'Si' put: 4.
			aDictionary at: 'P' put: 3.
			aDictionary at: 'S' put: 2.
			aDictionary at: 'Cl' put: 1.
			aDictionary at: 'Ar' put: 0.
			aDictionary at: 'K' put: 1.
			aDictionary at: 'Ca' put: 2.
			AtomicBonds := aDictionary].
	^AtomicBonds</body>

<body package="ChemoJun-Basic-Objects" selector="atomicBondsAt:">atomicBondsAt: atomicSymbol 
	"ChemoJunAtomObject atomicBondsAt: 'H'."

	^self atomicBonds at: atomicSymbol asString ifAbsent: [0]</body>

<body package="ChemoJun-Basic-Objects" selector="atomicColorAt:">atomicColorAt: atomicSymbol 
	"ChemoJunAtomObject atomicColorAt: 'H'."

	atomicSymbol isNil ifTrue: [^ColorValue veryLightGray].
	^self atomicColors at: atomicSymbol asString ifAbsent: [ColorValue veryLightGray]</body>

<body package="ChemoJun-Basic-Objects" selector="atomicColors">atomicColors
	"ChemoJunAtomObject atomicColors."

	"ChemoJunAtomObject flushConstants."

	| aDictionary definedAtoms definedColors undefinedAtoms totalSize colorValue |
	AtomicColors isNil 
		ifTrue: 
			[aDictionary := Dictionary new.
			aDictionary at: 'H' put: ColorValue veryLightGray.
			aDictionary at: 'C' put: ColorValue veryDarkGray.
			aDictionary at: 'N' put: ColorValue blue.
			aDictionary at: 'O' put: ColorValue red.
			aDictionary at: 'F' put: ColorValue brown.
			aDictionary at: 'Na' put: ColorValue cyan.
			aDictionary at: 'P' put: (ColorValue yellow blendWith: ColorValue black).
			aDictionary at: 'S' put: ColorValue yellow.
			aDictionary at: 'Cl' put: ColorValue green.
			aDictionary at: 'Br' put: ColorValue darkGreen.
			definedAtoms := aDictionary keys asSet.
			definedColors := aDictionary values asSet.
			undefinedAtoms := (self vanDerWaalsRadii keys 
						reject: [:atomicSymbol | definedAtoms includes: atomicSymbol]) 
							asSortedCollection asOrderedCollection.
			totalSize := undefinedAtoms size + definedAtoms size.
			(0 to: totalSize by: 1 / totalSize) do: 
					[:hueValue | 
					undefinedAtoms isEmpty 
						ifFalse: 
							[colorValue := ColorValue 
										hue: hueValue
										saturation: 1
										brightness: 1.
							(definedColors includes: colorValue) 
								ifFalse: 
									[| atomicSymbol |
									atomicSymbol := undefinedAtoms removeFirst.
									aDictionary at: atomicSymbol put: colorValue]]].
			AtomicColors := aDictionary].
	^AtomicColors</body>

<body package="ChemoJun-Basic-Objects" selector="flushConstants">flushConstants
	"ChemoJunAtomObject flushConstants."

	VanDerWaalsRadii := nil.
	AtomicColors := nil.
	AtomicBonds := nil</body>

<body package="ChemoJun-Basic-Objects" selector="vanDerWaalsRadii">vanDerWaalsRadii
	"ChemoJunAtomObject vanDerWaalsRadii."

	"ChemoJunAtomObject flushConstants."

	VanDerWaalsRadii isNil 
		ifTrue: 
			[| aDictionary |
			aDictionary := Dictionary new.
			aDictionary at: 'H' put: 1.2d.
			aDictionary at: 'He' put: 1.4d.
			aDictionary at: 'Li' put: 1.82d.
			aDictionary at: 'Be' put: 0.0d.
			aDictionary at: 'B' put: 1.75d.
			aDictionary at: 'C' put: 1.7d.
			aDictionary at: 'N' put: 1.55d.
			aDictionary at: 'O' put: 1.52d.
			aDictionary at: 'F' put: 1.47d.
			aDictionary at: 'Ne' put: 1.54d.
			aDictionary at: 'Na' put: 2.27d.
			aDictionary at: 'Mg' put: 1.73d.
			aDictionary at: 'Al' put: 1.78d.
			aDictionary at: 'Si' put: 2.1d.
			aDictionary at: 'P' put: 1.8d.
			aDictionary at: 'S' put: 1.8d.
			aDictionary at: 'Cl' put: 1.75d.
			aDictionary at: 'Ar' put: 1.88d.
			aDictionary at: 'K' put: 2.75d.
			aDictionary at: 'Ca' put: 2.32d.
			aDictionary at: 'Sc' put: 1.98d.
			aDictionary at: 'Ti' put: 1.8d.
			aDictionary at: 'V' put: 1.66d.
			aDictionary at: 'Cr' put: 1.6d.
			aDictionary at: 'Mn' put: 1.47d.
			aDictionary at: 'Fe' put: 1.59d.
			aDictionary at: 'Co' put: 1.6d.
			aDictionary at: 'Ni' put: 1.63d.
			aDictionary at: 'Cu' put: 1.4d.
			aDictionary at: 'Zn' put: 1.39d.
			aDictionary at: 'Ga' put: 0.0d.
			aDictionary at: 'Ge' put: 1.98d.
			aDictionary at: 'As' put: 1.85d.
			aDictionary at: 'Se' put: 1.9d.
			aDictionary at: 'Br' put: 1.85d.
			aDictionary at: 'Kr' put: 2.02d.
			aDictionary at: 'Rb' put: 0.0d.
			aDictionary at: 'Sr' put: 0.0d.
			aDictionary at: 'Y ' put: 0.0d.
			aDictionary at: 'Zr' put: 0.0d.
			aDictionary at: 'Nb' put: 0.0d.
			aDictionary at: 'Mo' put: 0.0d.
			aDictionary at: 'Tc' put: 0.0d.
			aDictionary at: 'Ru' put: 0.0d.
			aDictionary at: 'Rh' put: 0.0d.
			aDictionary at: 'Pd' put: 1.63d.
			aDictionary at: 'Ag' put: 1.72d.
			aDictionary at: 'Cd' put: 1.58d.
			aDictionary at: 'In' put: 1.93d.
			aDictionary at: 'Sn' put: 2.16d.
			aDictionary at: 'Sb' put: 2.12d.
			aDictionary at: 'Te' put: 2.06d.
			aDictionary at: 'I ' put: 1.98d.
			aDictionary at: 'Xe' put: 2.16d.
			aDictionary at: 'Cs' put: 0.0d.
			aDictionary at: 'Ba' put: 0.0d.
			aDictionary at: 'La' put: 0.0d.
			aDictionary at: 'Ce' put: 0.0d.
			aDictionary at: 'Pr' put: 0.0d.
			aDictionary at: 'Nd' put: 0.0d.
			aDictionary at: 'Pm' put: 0.0d.
			aDictionary at: 'Sm' put: 0.0d.
			aDictionary at: 'Eu' put: 0.0d.
			aDictionary at: 'Gd' put: 0.0d.
			aDictionary at: 'Tb' put: 0.0d.
			aDictionary at: 'Dy' put: 0.0d.
			aDictionary at: 'Ho' put: 0.0d.
			aDictionary at: 'Er' put: 0.0d.
			aDictionary at: 'Tm' put: 0.0d.
			aDictionary at: 'Yb' put: 0.0d.
			aDictionary at: 'Lu' put: 0.0d.
			aDictionary at: 'Hf' put: 0.0d.
			aDictionary at: 'Ta' put: 0.0d.
			aDictionary at: 'W ' put: 0.0d.
			aDictionary at: 'Re' put: 0.0d.
			aDictionary at: 'Os' put: 0.0d.
			aDictionary at: 'Ir' put: 0.0d.
			aDictionary at: 'Pt' put: 1.75d.
			aDictionary at: 'Au' put: 1.66d.
			aDictionary at: 'Hg' put: 1.55d.
			aDictionary at: 'Tl' put: 1.96d.
			aDictionary at: 'Pb' put: 2.02d.
			aDictionary at: 'Bi' put: 0.0d.
			aDictionary at: 'Po' put: 0.0d.
			aDictionary at: 'At' put: 0.0d.
			aDictionary at: 'Rn' put: 0.0d.
			aDictionary at: 'Fr' put: 0.0d.
			aDictionary at: 'Ra' put: 0.0d.
			aDictionary at: 'Ac' put: 0.0d.
			aDictionary at: 'Th' put: 0.0d.
			aDictionary at: 'Pa' put: 0.0d.
			aDictionary at: 'U ' put: 0.0d.
			aDictionary at: 'Np' put: 0.0d.
			aDictionary at: 'Pu' put: 0.0d.
			aDictionary at: 'Am' put: 0.0d.
			aDictionary at: 'Cm' put: 0.0d.
			aDictionary at: 'Bk' put: 0.0d.
			aDictionary at: 'Cf' put: 0.0d.
			aDictionary at: 'Es' put: 0.0d.
			aDictionary at: 'Fm' put: 0.0d.
			aDictionary at: 'Md' put: 0.0d.
			aDictionary at: 'No' put: 0.0d.
			aDictionary at: 'Lr' put: 0.0d.
			VanDerWaalsRadii := aDictionary].
	^VanDerWaalsRadii</body>

<body package="ChemoJun-Basic-Objects" selector="vanDerWaalsRadiusAt:">vanDerWaalsRadiusAt: atomicSymbol 
	"ChemoJunAtomObject vanDerWaalsRadiusAt: 'H'."

	^self vanDerWaalsRadii at: atomicSymbol asString ifAbsent: [1.0d]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject class</class-id> <category>copyright</category>

<body package="ChemoJun-Basic-Objects" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Basic-Objects" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Basic-Objects" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject class</class-id> <category>defaults</category>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomConnectionClass">defaultAtomConnectionClass
	^self defaultMoleculeObjectClass defaultAtomConnectionClass</body>

<body package="ChemoJun-Basic-Objects" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^ChemoJunMoleculeObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject class</class-id> <category>examples</category>

<body package="ChemoJun-Basic-Objects" selector="example1">example1
	"ChemoJunAtomObject example1."

	| atomObject |
	atomObject := ChemoJunAtomObject new.
	^atomObject</body>

<body package="ChemoJun-Basic-Objects" selector="example2">example2
	"ChemoJunAtomObject example2."

	| atomObject |
	atomObject := ChemoJunAtomObject new.
	atomObject defaultAtomicBody show.
	^atomObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunAtomObject</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>initialize-release</category>

<body package="ChemoJun-Basic-Objects" selector="initialize">initialize
	super initialize.
	atomicSymbol := nil.
	atomicPoint := nil.
	atomicRadius := nil.
	atomicBody := nil.
	areaCoefficient := nil.
	attributeTable := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>accessing</category>

<body package="ChemoJun-Basic-Objects" selector="areaCoefficient">areaCoefficient
	^areaCoefficient</body>

<body package="ChemoJun-Basic-Objects" selector="areaCoefficient:">areaCoefficient: coefficient 
	areaCoefficient := coefficient</body>

<body package="ChemoJun-Basic-Objects" selector="atomicArea">atomicArea
	^(Jun3dBoundingBall center: self atomicPoint radius: self atomicRadius) 
		area</body>

<body package="ChemoJun-Basic-Objects" selector="atomicBody">atomicBody
	^atomicBody</body>

<body package="ChemoJun-Basic-Objects" selector="atomicBody:">atomicBody: aBody 
	atomicBody := aBody asJunOpenGL3dObject</body>

<body package="ChemoJun-Basic-Objects" selector="atomicPoint">atomicPoint
	atomicPoint isNil ifTrue: [atomicPoint := self defaultAtomicPoint].
	^atomicPoint</body>

<body package="ChemoJun-Basic-Objects" selector="atomicPoint:">atomicPoint: aPoint 
	aPoint isNil
		ifTrue: [atomicPoint := self defaultAtomicPoint]
		ifFalse: [atomicPoint := Jun3dPoint fromPoint: aPoint]</body>

<body package="ChemoJun-Basic-Objects" selector="atomicRadius">atomicRadius
	atomicRadius isNil ifTrue: [atomicRadius := self defaultAtomicRadius].
	^atomicRadius</body>

<body package="ChemoJun-Basic-Objects" selector="atomicRadius:">atomicRadius: aNumber 
	aNumber isNil
		ifTrue: [atomicRadius := self defaultAtomicRadius]
		ifFalse: [atomicRadius := aNumber asDouble]</body>

<body package="ChemoJun-Basic-Objects" selector="atomicSymbol">atomicSymbol
	atomicSymbol isNil ifTrue: [atomicSymbol := self defaultAtomicSymbol].
	^atomicSymbol</body>

<body package="ChemoJun-Basic-Objects" selector="atomicSymbol:">atomicSymbol: aString 
	aString isNil 
		ifTrue: [atomicSymbol := self defaultAtomicSymbol]
		ifFalse: [atomicSymbol := aString asString]</body>

<body package="ChemoJun-Basic-Objects" selector="frontierArea">frontierArea
	| area |
	self atomicBody ifNil: [area := self atomicArea]
		ifNotNil: 
			[:atomBody | 
			area := atomBody area.
			self areaCoefficient ifNotNil: [:coefficient | area := area * coefficient]].
	^area</body>

<body package="ChemoJun-Basic-Objects" selector="interierArea">interierArea
	^self atomicArea - self frontierArea</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>attribute accessing</category>

<body package="ChemoJun-Basic-Objects" selector="atomicColor">atomicColor
	^self attributeTable at: #atomicColor
		ifAbsent: [self class atomicColorAt: self atomicSymbol]</body>

<body package="ChemoJun-Basic-Objects" selector="atomicColor:">atomicColor: colorValue 
	colorValue ifNil: [self attributeTable removeKey: #atomicColor]
		ifNotNil: [:it | self attributeTable at: #atomicColor put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="attributeTable">attributeTable
	attributeTable isNil ifTrue: [attributeTable := JunAttributeTable new].
	^attributeTable</body>

<body package="ChemoJun-Basic-Objects" selector="displayBooleanOfModifier">displayBooleanOfModifier
	^self attributeTable at: #displayBooleanOfModifier ifAbsent: [false]</body>

<body package="ChemoJun-Basic-Objects" selector="displayBooleanOfModifier:">displayBooleanOfModifier: aBoolean 
	aBoolean ifNil: [self attributeTable removeKey: #displayBooleanOfModifier]
		ifNotNil: [:it | self attributeTable at: #displayBooleanOfModifier put: it = true]</body>

<body package="ChemoJun-Basic-Objects" selector="displayBooleanOfSerialNumber">displayBooleanOfSerialNumber
	^self attributeTable at: #displayBooleanOfSerialNumber ifAbsent: [false]</body>

<body package="ChemoJun-Basic-Objects" selector="displayBooleanOfSerialNumber:">displayBooleanOfSerialNumber: aBoolean 
	aBoolean 
		ifNil: [self attributeTable removeKey: #displayBooleanOfSerialNumber]
		ifNotNil: 
			[:it | 
			self attributeTable at: #displayBooleanOfSerialNumber put: it = true]</body>

<body package="ChemoJun-Basic-Objects" selector="displayBoxOfModifier">displayBoxOfModifier
	^self attributeTable at: #displayBoxOfModifier ifAbsent: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="displayBoxOfModifier:">displayBoxOfModifier: aBox 
	aBox ifNil: [self attributeTable removeKey: #displayBoxOfModifier]
		ifNotNil: [:it | self attributeTable at: #displayBoxOfModifier put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayBoxOfSerialNumber">displayBoxOfSerialNumber
	^self attributeTable at: #displayBoxOfSerialNumber ifAbsent: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="displayBoxOfSerialNumber:">displayBoxOfSerialNumber: aBox 
	aBox ifNil: [self attributeTable removeKey: #displayBoxOfSerialNumber]
		ifNotNil: [:it | self attributeTable at: #displayBoxOfSerialNumber put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayComposedTextOfSerialNumber">displayComposedTextOfSerialNumber
	^self attributeTable at: #displayComposedTextOfSerialNumber ifAbsent: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="displayComposedTextOfSerialNumber:">displayComposedTextOfSerialNumber: aComposedText 
	aComposedText 
		ifNil: [self attributeTable removeKey: #displayComposedTextOfSerialNumber]
		ifNotNil: [:it | self attributeTable at: #displayComposedTextOfSerialNumber put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayFocusAtomPointOfModifier">displayFocusAtomPointOfModifier
	^self attributeTable at: #displayFocusAtomPointOfModifier ifAbsent: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="displayFocusAtomPointOfModifier:">displayFocusAtomPointOfModifier: aPoint 
	aPoint 
		ifNil: [self attributeTable removeKey: #displayFocusAtomPointOfModifier]
		ifNotNil: [:it | self attributeTable at: #displayFocusAtomPointOfModifier put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayImageOfModifier">displayImageOfModifier
	^self attributeTable at: #displayImageOfModifier ifAbsent: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="displayImageOfModifier:">displayImageOfModifier: anImage 
	anImage ifNil: [self attributeTable removeKey: #displayImageOfModifier]
		ifNotNil: [:it | self attributeTable at: #displayImageOfModifier put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOffsetOfModifier">displayOffsetOfModifier
	^self attributeTable at: #displayOffsetOfModifier ifAbsent: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOffsetOfModifier:">displayOffsetOfModifier: aPoint 
	aPoint ifNil: [self attributeTable removeKey: #displayOffsetOfModifier]
		ifNotNil: [:it | self attributeTable at: #displayOffsetOfModifier put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOffsetOfSerialNumber">displayOffsetOfSerialNumber
	^self attributeTable at: #displayOffsetOfSerialNumber ifAbsent: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOffsetOfSerialNumber:">displayOffsetOfSerialNumber: aPoint 
	aPoint 
		ifNil: [self attributeTable removeKey: #displayOffsetOfSerialNumber]
		ifNotNil: [:it | self attributeTable at: #displayOffsetOfSerialNumber put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOrderOfModifier">displayOrderOfModifier
	^self attributeTable at: #displayOrderOfModifier ifAbsent: [0]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOrderOfModifier:">displayOrderOfModifier: zValue 
	zValue ifNil: [self attributeTable removeKey: #displayOrderOfModifier]
		ifNotNil: [:it | self attributeTable at: #displayOrderOfModifier put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOrderOfSerialNumber">displayOrderOfSerialNumber
	^self attributeTable at: #displayOrderOfSerialNumber ifAbsent: [0]</body>

<body package="ChemoJun-Basic-Objects" selector="displayOrderOfSerialNumber:">displayOrderOfSerialNumber: zValue 
	zValue ifNil: [self attributeTable removeKey: #displayOrderOfSerialNumber]
		ifNotNil: [:it | self attributeTable at: #displayOrderOfSerialNumber put: it]</body>

<body package="ChemoJun-Basic-Objects" selector="serialNumber">serialNumber
	^self attributeTable at: #serialNumber ifAbsent: [0]</body>

<body package="ChemoJun-Basic-Objects" selector="serialNumber:">serialNumber: positiveInteger 
	positiveInteger ifNil: [self attributeTable removeKey: #serialNumber]
		ifNotNil: [:it | self attributeTable at: #serialNumber put: it]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>copying</category>

<body package="ChemoJun-Basic-Objects" selector="postCopy">postCopy
	super postCopy.
	atomicPoint := atomicPoint copy.
	atomicBody := atomicBody copy.
	attributeTable := attributeTable copy</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>defaults</category>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomicBody">defaultAtomicBody
	| aBall centerPoint radiusValue colorValue aTransformation aSphere |
	aBall := JunOpenGL3dObject ball: 2.
	centerPoint := self atomicPoint.
	radiusValue := self atomicRadius.
	colorValue := (self class atomicColorAt: self atomicSymbol) 
				blendWith: ColorValue white.
	aTransformation := (Jun3dTransformation 
				scale: radiusValue , radiusValue , radiusValue) 
					product: (Jun3dTransformation translate: centerPoint).
	aSphere := aBall transform: aTransformation.
	aSphere polygonsDo: [:aPolygon | aPolygon paint: colorValue].
	^aSphere</body>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomicPoint">defaultAtomicPoint
	^0.0d , 0.0d , 0.0d</body>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomicRadius">defaultAtomicRadius
	^0.37d</body>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomicSymbol">defaultAtomicSymbol
	^'H' copy</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>functions</category>

<body package="ChemoJun-Basic-Objects" selector="distanceFrom:">distanceFrom: aPoint 
	^(self to: aPoint) length</body>

<body package="ChemoJun-Basic-Objects" selector="from:">from: aPoint 
	^self atomicPoint from: aPoint</body>

<body package="ChemoJun-Basic-Objects" selector="to:">to: aPoint 
	^self atomicPoint to: aPoint</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>printing</category>

<body package="ChemoJun-Basic-Objects" selector="printOn:">printOn: aStream 
	aStream nextPutAll: '('.
	aStream nextPutAll: self serialNumber printString.
	aStream space.
	aStream nextPutAll: self atomicSymbol printString.
	aStream space.
	aStream nextPutAll: self atomicPoint printString.
	aStream space.
	aStream nextPutAll: self atomicRadius printString.
	aStream nextPutAll: ')'</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAtomObject</class-id> <category>testing</category>

<body package="ChemoJun-Basic-Objects" selector="containsPoint:">containsPoint: aPoint 
	^(self atomicPoint distance: aPoint) &lt;= self atomicRadius</body>

<body package="ChemoJun-Basic-Objects" selector="hasAtomicColor">hasAtomicColor
	^self attributeTable includesKey: #atomicColor</body>

<body package="ChemoJun-Basic-Objects" selector="isCarbon">isCarbon
	^self atomicSymbol = 'C'</body>

<body package="ChemoJun-Basic-Objects" selector="isChlorine">isChlorine
	^self atomicSymbol = 'Cl'</body>

<body package="ChemoJun-Basic-Objects" selector="isFluorine">isFluorine
	^self atomicSymbol = 'F'</body>

<body package="ChemoJun-Basic-Objects" selector="isHydrogen">isHydrogen
	^self atomicSymbol = 'H'</body>

<body package="ChemoJun-Basic-Objects" selector="isNitrogen">isNitrogen
	^self atomicSymbol = 'N'</body>

<body package="ChemoJun-Basic-Objects" selector="isOxygen">isOxygen
	^self atomicSymbol = 'O'</body>

<body package="ChemoJun-Basic-Objects" selector="isPhosphorus">isPhosphorus
	^self atomicSymbol = 'P'</body>

<body package="ChemoJun-Basic-Objects" selector="isSilicon">isSilicon
	^self atomicSymbol = 'Si'</body>

<body package="ChemoJun-Basic-Objects" selector="isSulfur">isSulfur
	^self atomicSymbol = 'S'</body>
</methods>

<initialize>
<class-id>ChemoJun.ChemoJunAtomObject</class-id>
</initialize>


</st-source>
