<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76978 "21:22:58"))'</do-it>



<class>
<name>ChemoJunImageCatalog</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunApplicationModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>columnSize elementExtent catalogElements boundingBox selectedElements catalogFilename preferenceTable </inst-vars>
<class-inst-vars>catalogProgress </class-inst-vars>
<imports></imports>
<category>ChemoJun-Catalog-Image</category>
<attributes>
<package>ChemoJun-Catalog-Image</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>class initialization</category>

<body package="ChemoJun-Catalog-Image" selector="initialize">initialize
	catalogProgress := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>instance creation</category>

<body package="ChemoJun-Catalog-Image" selector="filename:">filename: catalogFilename 
	| aList aCatalog |
	self 
		assert: [catalogFilename asFilename readStream]
		do: [:aStream | Cursor read showWhile: [aList := JunLispParser parse: aStream]]
		ensure: [:aStream | aStream close].
	Cursor wait showWhile: 
			[aCatalog := (self fromLispList: aList)
						filename: catalogFilename;
						yourself].
	^aCatalog</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>accessing</category>

<body package="ChemoJun-Catalog-Image" selector="catalogProgress">catalogProgress
	catalogProgress ifNil: [catalogProgress := JunProgress new].
	^catalogProgress</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>copyright</category>

<body package="ChemoJun-Catalog-Image" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Catalog-Image" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Catalog-Image" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>defaults</category>

<body package="ChemoJun-Catalog-Image" selector="defaultCatalogElementClass">defaultCatalogElementClass
	^ChemoJunImageCatalogElement</body>

<body package="ChemoJun-Catalog-Image" selector="defaultCatalogVoidClass">defaultCatalogVoidClass
	^ChemoJunImageCatalogVoid</body>

<body package="ChemoJun-Catalog-Image" selector="defaultElementExtent">defaultElementExtent
	^self defaultCatalogElementClass defaultElementExtent</body>

<body package="ChemoJun-Catalog-Image" selector="defaultElementMargin">defaultElementMargin
	^6 @ 6</body>

<body package="ChemoJun-Catalog-Image" selector="defaultMolecueCatalogViewClass">defaultMolecueCatalogViewClass
	^ChemoJunImageCatalogView</body>

<body package="ChemoJun-Catalog-Image" selector="defaultViewerExtent">defaultViewerExtent
	^400 @ 400</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>examples</category>

<body package="ChemoJun-Catalog-Image" selector="example1">example1
	"ChemoJunImageCatalog example1."

	| aCatalog |
	(aCatalog := ChemoJunImageCatalog request) ifNil: [^nil].
	JunImageDisplayModel show: aCatalog asImage.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="example2">example2
	"ChemoJunImageCatalog example2."

	| aCatalog |
	aCatalog := ChemoJunImageCatalog new.
	aCatalog open.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="example3">example3
	"ChemoJunImageCatalog example3."

	| aCatalog selectedElements |
	(aCatalog := ChemoJunImageCatalog request) ifNil: [^nil].
	aCatalog multiSelections: true.
	selectedElements := OrderedCollection new.
	aCatalog elements with: (1 to: aCatalog elements size)
		do: [:element :index | index even ifTrue: [selectedElements add: element]].
	aCatalog selections: selectedElements.
	aCatalog open.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="example4">example4
	"ChemoJunImageCatalog example4."

	| aDirectory aCatalog |
	(aDirectory := ChemoJunFileRequesterDialog requestDirectory) ifNil: [^nil].
	aCatalog := (ChemoJunImageCatalog new)
				directory: aDirectory;
				yourself.
	aCatalog open.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="example5">example5
	"ChemoJunImageCatalog example5."

	| aDirectory aCatalog |
	(aDirectory := ChemoJunFileRequesterDialog requestDirectory) ifNil: [^nil].
	aCatalog := ChemoJunImageCatalog new.
	aCatalog directories: (Array with: aDirectory with: aDirectory).
	aCatalog open.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="example6">example6
	"ChemoJunImageCatalog example6."

	| aDirectory aCatalog lispList |
	(aDirectory := ChemoJunFileRequesterDialog requestDirectory) ifNil: [^nil].
	aCatalog := (ChemoJunImageCatalog new)
				directory: aDirectory;
				yourself.
	lispList := aCatalog toLispList.
	Transcript
		clear;
		show: lispList saveString.
	aCatalog := aCatalog class fromLispList: lispList.
	lispList := aCatalog toLispList.
	Transcript
		cr;
		show: lispList saveString.
	^aCatalog</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>interface specs</category>

<body package="ChemoJun-Catalog-Image" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 
			#(#{Kernel.UserMessage} 
				#key: #chemoJun_Molecular_Image_Catalog 
				#defaultString: 'Molecular Image Catalog' ) 
			#min: #(#{Core.Point} 300 300 ) 
			#max: #(#{Core.Point} 0 0 ) 
			#bounds: #(#{Graphics.Rectangle} 700 468 1397 1050 ) 
			#flags: 4 
			#menu: #menuBar 
			#colors: 
			#(#{UI.LookPreferences} 
				#setBackgroundColor: #(#{Graphics.ColorValue} 7700 7700 7700 ) ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} 1 0 1 0 -1 1 -1 1 ) 
					#name: #catalogView 
					#flags: 11 
					#component: #catalogView ) ) ) )</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Image" selector="catalogElementsFromTable:for:">catalogElementsFromTable: aTable for: aCatalog 
	| aList aCollection |
	aList := aTable at: #catalogElements ifAbsent: [^aCatalog].
	aCollection := OrderedCollection new: aList size.
	aList do: 
			[:list | 
			| element |
			list ifNil: [element := nil]
				ifNotNil: [element := (Smalltalk at: list head) fromLispList: list].
			aCollection add: element].
	self catalogProgress doWithStopButton: [aCatalog elements: aCollection].
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="columnSizeFromTable:for:">columnSizeFromTable: aTable for: aCatalog 
	| columnSize |
	columnSize := aTable at: #columnSize ifAbsent: [^aCatalog].
	aCatalog columnSize: columnSize.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="elementExtentFromTable:for:">elementExtentFromTable: aTable for: aCatalog 
	| elementExtent |
	elementExtent := aTable at: #elementExtent ifAbsent: [^aCatalog].
	aCatalog elementExtent: elementExtent.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="fromLispList:for:">fromLispList: aList for: aCatalog 
	| aTable |
	aTable := self tableFromLispList: aList tail.
	self columnSizeFromTable: aTable for: aCatalog.
	self elementExtentFromTable: aTable for: aCatalog.
	self catalogElementsFromTable: aTable for: aCatalog.
	self selectedElementsFromTable: aTable for: aCatalog.
	self preferenceTableFromTable: aTable for: aCatalog.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTableFromTable:for:">preferenceTableFromTable: aTable for: aCatalog 
	| aList preferenceTable |
	aList := aTable at: #preferenceTable ifAbsent: [^aCatalog].
	preferenceTable := JunAttributeTable fromLispList: aList.
	aCatalog preferenceTable: preferenceTable.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Image" selector="selectedElementsFromTable:for:">selectedElementsFromTable: aTable for: aCatalog 
	| aList |
	aList := aTable at: #selectedElements ifAbsent: [^aCatalog].
	aCatalog 
		selections: (aList collect: [:index | aCatalog elements at: index]) asArray.
	^aCatalog</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>resources</category>

<body package="ChemoJun-Catalog-Image" selector="menuBar">menuBar
	"Tools.MenuEditor new openOnClass: self andSelector: #menuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_File 
					#defaultString: 'File' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_New 
								#defaultString: 'New' ) 
							#value: #newModel ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Select_Directory 
								#defaultString: 'Select Directory' ) 
							#value: #selectDirectory ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Open_Catalog_File 
								#defaultString: 'Open Catalog File' ) 
							#value: #openCatalogFile ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Open_SD_File 
								#defaultString: 'Open SD File' ) 
							#value: #openSDFile ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_Catalog_File 
								#defaultString: 'Save Catalog File' ) 
							#value: #saveCatalog ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_Catalog_File 
								#defaultString: 'Save as Catalog File' ) 
							#value: #saveAsCatalog ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_SD_File 
								#defaultString: 'Save as SD File' ) 
							#value: #saveAsSDFile ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_Image 
								#defaultString: 'Save as Image' ) 
							#value: #saveAsImage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_HTML 
								#defaultString: 'Save as HTML' ) 
							#value: #saveAsHTML ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Quit 
								#defaultString: 'Quit' ) 
							#value: #quitDoing ) ) #(1 3 3 2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Edit 
					#defaultString: 'Edit' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Open_Molecular_Viewer 
								#defaultString: 'Open Molecular Viewer' ) 
							#value: #openMoleculeViewer ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Remove 
								#defaultString: 'Remove' ) 
							#value: #removeElements ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Select_all 
								#defaultString: 'Select All' ) 
							#value: #selectAll ) ) #(2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_View 
					#defaultString: 'View' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Show_Indexes 
								#defaultString: 'Indexes' ) 
							#value: #toggleCatalogIndex ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Show_File_Name 
								#defaultString: 'File Name' ) 
							#value: #toggleFileName ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Column_Size 
								#defaultString: 'Column Size' ) 
							#value: #arrangeColumnSize ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Condense 
								#defaultString: 'Condense' ) 
							#value: #condenseElements ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Element_Extent 
								#defaultString: 'Element Extent' ) 
							#value: #reviseElementExtent ) ) #(2 2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Misc 
					#defaultString: 'Misc' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Manual 
								#defaultString: 'Manual' ) 
							#value: #browseManual ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Inspect 
								#defaultString: 'Inspect' ) 
							#value: #inspectModel ) ) #(1 1 ) nil ) ) ) #(4 ) nil ) decodeAsLiteralArray</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog class</class-id> <category>utilities</category>

<body package="ChemoJun-Catalog-Image" selector="request">request
	"ChemoJunImageCatalog request."

	| labels values menu filename catalog |
	labels := Array with: (Array 
						with: (#chemoJun_Molecular_image_catalog_files 
								&gt;&gt; 'Molecular image catalog files') asString).
	values := Array with: #('*.mic' '*.MIC').
	menu := Menu labelList: labels values: values.
	filename := ChemoJunFileRequesterDialog 
				requestFilename: (#chemoJun_Select_a_molecular_image_catalog_file_ 
						&gt;&gt; 'Select a molecular image catalog file.') asString
				fileTypeMenu: menu
				initialFileType: values first.
	filename isNil ifTrue: [^nil].
	catalog := self filename: filename.
	^catalog</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>initialize-release</category>

<body package="ChemoJun-Catalog-Image" selector="initialize">initialize
	super initialize.
	columnSize := nil.
	elementExtent := nil.
	catalogElements := nil.
	boundingBox := nil.
	selectedElements := nil.
	catalogFilename := nil.
	preferenceTable := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>accessing</category>

<body package="ChemoJun-Catalog-Image" selector="columnSize">columnSize
	columnSize ifNil: [columnSize := self defaultColumnSize].
	^columnSize</body>

<body package="ChemoJun-Catalog-Image" selector="columnSize:">columnSize: numberOfColumns 
	columnSize := numberOfColumns.
	self elements: self elements</body>

<body package="ChemoJun-Catalog-Image" selector="elementExtent">elementExtent
	elementExtent ifNil: [elementExtent := self class defaultElementExtent].
	^elementExtent</body>

<body package="ChemoJun-Catalog-Image" selector="elementExtent:">elementExtent: aPoint 
	elementExtent := aPoint asPoint rounded.
	self isEmpty 
		ifFalse: 
			[self class catalogProgress 
				doWithStopButton: [self elements: self elements]]</body>

<body package="ChemoJun-Catalog-Image" selector="elements">elements
	catalogElements ifNil: [catalogElements := OrderedCollection new].
	^catalogElements</body>

<body package="ChemoJun-Catalog-Image" selector="elements:">elements: aCollection 
	self 
		assert: 
			[catalogElements := aCollection.
			boundingBox := Point zero extent: Point zero]
		do: 
			[| aProgress |
			aProgress := self class catalogProgress.
			aProgress
				value: 0;
				message: String new.
			catalogElements with: (0 to: catalogElements size - 1)
				do: 
					[:element :n | 
					| y x |
					y := n // self columnSize + 1.
					x := n \\ self columnSize + 1.
					element ifNotNil: 
							[| originPoint displayBox |
							aProgress message: element tailName.
							originPoint := self elementExtent * ((x - 1) @ (y - 1)).
							displayBox := originPoint extent: self elementExtent.
							displayBox := displayBox 
										translatedBy: self class defaultElementMargin * (x @ y).
							element bounds: displayBox.
							boundingBox := boundingBox merge: displayBox].
					aProgress value: (n + 1) / catalogElements size.
					(aProgress isOpen and: [aProgress stopButtonPressed]) 
						ifTrue: 
							[aProgress close.
							[catalogElements size &gt; (n + 1)] whileTrue: [catalogElements removeLast].
							^nil]].
			self do: 
					[aProgress
						value: 1;
						message: String new]
				forMilliseconds: 100]
		ensure: 
			[boundingBox := boundingBox origin 
						corner: boundingBox corner + self class defaultElementMargin.
			selectedElements := nil]</body>

<body package="ChemoJun-Catalog-Image" selector="filename">filename
	^catalogFilename</body>

<body package="ChemoJun-Catalog-Image" selector="filename:">filename: aFilename 
	aFilename ifNil: [catalogFilename := nil]
		ifNotNil: [:it | catalogFilename := it asFilename].
	self setWindowLabel</body>

<body package="ChemoJun-Catalog-Image" selector="moleculeObjects">moleculeObjects
	| moleculeObjects |
	moleculeObjects := OrderedCollection new.
	self elements 
		do: [:element | element moleculeObject ifNotNil: [:it | moleculeObjects add: it]].
	^moleculeObjects</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>actions</category>

<body package="ChemoJun-Catalog-Image" selector="dropElements:toCatalog:">dropElements: elements toCatalog: catalog 
	| selections |
	catalog ifNil: [^nil].
	selections := (elements asSortedCollection: 
					[:e1 :e2 | 
					(self elements indexOf: e1) &lt; (self elements indexOf: e2)]) 
				collect: [:element | element copy].
	catalog elements: catalog elements , selections.
	catalog selections: selections.
	catalog scrollFor: selections first.
	catalog clearAndRedisplay</body>

<body package="ChemoJun-Catalog-Image" selector="dropTargetCatalog">dropTargetCatalog
	| aPoint aController aWindow aModel |
	aPoint := JunSensorUtility cursorPoint.
	aController := (ScheduledControllers
				updateControllerOrder;
				scheduledControllers) reverse 
				detect: 
					[:controller | 
					aWindow := controller view.
					aWindow displayBox containsPoint: aPoint]
				ifNone: [nil].
	aController ifNil: [^nil].
	aModel := aController model.
	aModel = self ifTrue: [^nil].
	(aModel isKindOf: self class) ifFalse: [^nil].
	^aModel</body>

<body package="ChemoJun-Catalog-Image" selector="move1Elements:toElement:">move1Elements: elements toElement: target 
	| attractiveElement attractiveElements elementCollection elementIndex targetIndex headCollection tailCollection |
	attractiveElement := elements last.
	attractiveElements := (elements asSortedCollection: 
					[:e1 :e2 | 
					(self elements indexOf: e1) &lt; (self elements indexOf: e2)]) 
				asOrderedCollection.
	elementCollection := self elements copy asOrderedCollection.
	elementIndex := elementCollection 
				findFirst: [:each | each = attractiveElement].
	elementIndex &lt; 1 ifTrue: [^nil].
	targetIndex := elementCollection findFirst: [:each | each = target].
	targetIndex &lt; 1 ifTrue: [^nil].
	elementIndex &lt; targetIndex 
		ifTrue: 
			[headCollection := elementCollection copyFrom: 1 to: targetIndex.
			tailCollection := elementCollection copyFrom: targetIndex + 1
						to: elementCollection size]
		ifFalse: 
			[headCollection := elementCollection copyFrom: 1 to: targetIndex - 1.
			tailCollection := elementCollection copyFrom: targetIndex
						to: elementCollection size].
	attractiveElements 
		do: [:element | headCollection remove: element ifAbsent: [nil]].
	attractiveElements 
		do: [:element | tailCollection remove: element ifAbsent: [nil]].
	elementCollection := OrderedCollection new.
	elementCollection addAll: headCollection.
	attractiveElements remove: attractiveElement.
	attractiveElements do: 
			[:element | 
			elementCollection size = (targetIndex - 1) 
				ifTrue: [elementCollection add: attractiveElement].
			elementCollection add: element].
	elementCollection size = (targetIndex - 1) 
		ifTrue: [elementCollection add: attractiveElement].
	elementCollection addAll: tailCollection.
	self elements: elementCollection.
	self selections: elements.
	self redisplay</body>

<body package="ChemoJun-Catalog-Image" selector="move2Elements:toElement:">move2Elements: elements toElement: target 
	| attractiveElement attractiveElements elementCollection elementIndex targetIndex headCollection tailCollection voidElements |
	attractiveElement := elements last.
	attractiveElements := (elements asSortedCollection: 
					[:e1 :e2 | 
					(self elements indexOf: e1) &lt; (self elements indexOf: e2)]) 
				asOrderedCollection.
	attractiveElements remove: attractiveElement.
	attractiveElements addFirst: attractiveElement.
	elementCollection := self elements copy asOrderedCollection.
	elementIndex := elementCollection 
				findFirst: [:element | element = attractiveElement].
	elementIndex &lt; 1 ifTrue: [^nil].
	targetIndex := elementCollection findFirst: [:element | element = target].
	targetIndex &lt; 1 ifTrue: [^nil].
	headCollection := elementCollection copyFrom: 1 to: targetIndex - 1.
	tailCollection := elementCollection copyFrom: targetIndex
				to: elementCollection size.
	headCollection with: (1 to: headCollection size)
		do: 
			[:element :index | 
			(attractiveElements includes: element) 
				ifTrue: 
					[headCollection at: index put: self class defaultCatalogVoidClass new]].
	tailCollection with: (1 to: tailCollection size)
		do: 
			[:element :index | 
			(attractiveElements includes: element) 
				ifTrue: 
					[tailCollection at: index put: self class defaultCatalogVoidClass new]].
	voidElements := tailCollection select: [:element | element isVoid].
	voidElements isEmpty 
		ifFalse: 
			[(voidElements copyFrom: 1
				to: (attractiveElements size min: voidElements size)) 
					do: [:void | tailCollection remove: void]].
	elementCollection := OrderedCollection new.
	elementCollection addAll: headCollection.
	elementCollection addAll: attractiveElements.
	elementCollection addAll: tailCollection.
	self elements: elementCollection.
	self selections: elements.
	self clearAndRedisplay</body>

<body package="ChemoJun-Catalog-Image" selector="moveElements:toElement:">moveElements: elements toElement: target 
	(JunSensorUtility shiftDown or: [JunSensorUtility altDown]) 
		ifTrue: [self move2Elements: elements toElement: target]
		ifFalse: [self move1Elements: elements toElement: target]</body>

<body package="ChemoJun-Catalog-Image" selector="pressedCameraButtonOf:in:">pressedCameraButtonOf: anElement in: aViewer 
	| anImage |
	aViewer ifNil: [^nil].
	anImage := aViewer 
				asImageExtent: anElement extent * anElement defaultImageMagnifyingFactor.
	anImage ifNil: [^nil].
	anImage := anElement decoratedImage: anImage.
	anElement
		fromPreferences: aViewer;
		thumbnail: anImage;
		computeMappingPoints: aViewer.
	self changed</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>bounds accessing</category>

<body package="ChemoJun-Catalog-Image" selector="boundingBox">boundingBox
	boundingBox ifNil: [boundingBox := Point zero extent: Point zero].
	^boundingBox</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>converting</category>

<body package="ChemoJun-Catalog-Image" selector="asImage">asImage
	| anImage |
	anImage := nil.
	self 
		assert: [Pixmap extent: self boundingBox extent]
		do: 
			[:aPixmap | 
			| graphicsContext |
			graphicsContext := aPixmap graphicsContext.
			graphicsContext paint: self backgroundColor.
			graphicsContext displayRectangle: aPixmap bounds.
			self displayOn: graphicsContext.
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	^anImage</body>

<body package="ChemoJun-Catalog-Image" selector="asImageOfElement:">asImageOfElement: element 
	^self 
		asImageOfElement: element
		selectionColor: self selectionColor
		backgroundColor: self backgroundColor</body>

<body package="ChemoJun-Catalog-Image" selector="asImageOfElement:selectionColor:backgroundColor:">asImageOfElement: element selectionColor: selectionColor backgroundColor: backgroundColor 
	| anImage |
	self 
		assert: [Pixmap extent: self pixmapExtent]
		do: 
			[:aPixmap | 
			self 
				displayElement: element
				index: (self elements indexOf: element)
				into: aPixmap
				selectionColor: selectionColor
				backgroundColor: backgroundColor.
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	^anImage</body>

<body package="ChemoJun-Catalog-Image" selector="asImageOfElements:">asImageOfElements: elements 
	^self 
		asImageOfElements: elements
		selectionColor: self selectionColor
		backgroundColor: self backgroundColor</body>

<body package="ChemoJun-Catalog-Image" selector="asImageOfElements:selectionColor:backgroundColor:">asImageOfElements: elements selectionColor: selectionColor backgroundColor: backgroundColor 
	| numberOfLimit elementImages offsetPoint aPixmap aMask pixmapContext maskContext aPoint figureImage shapeImage |
	numberOfLimit := 16.
	elementImages := (elements 
				copyFrom: (elements size - (numberOfLimit - 1) max: 1)
				to: elements size) collect: 
						[:element | 
						self 
							asImageOfElement: element
							selectionColor: selectionColor
							backgroundColor: backgroundColor].
	offsetPoint := 13 @ 13.
	self 
		assert: 
			[aPixmap := Pixmap extent: self pixmapExtent 
								+ (offsetPoint * (elementImages size - 1) asPoint).
			aMask := Mask extent: aPixmap extent]
		do: 
			[pixmapContext := aPixmap graphicsContext.
			pixmapContext paint: ColorValue white.
			pixmapContext displayRectangle: aPixmap bounds.
			maskContext := aMask graphicsContext.
			maskContext paint: CoverageValue transparent.
			maskContext displayRectangle: aMask bounds.
			maskContext paint: CoverageValue opaque.
			aPoint := aPixmap bounds bottomLeft - (0 @ self pixmapExtent y).
			elementImages do: 
					[:elementImage | 
					elementImage displayOn: pixmapContext at: aPoint.
					maskContext displayRectangle: (aPoint extent: elementImage extent).
					aPoint := aPoint + (offsetPoint x @ offsetPoint y negated)].
			figureImage := aPixmap asImage.
			shapeImage := aMask asImage]
		ensure: 
			[aPixmap close.
			aMask close].
	^OpaqueImage figure: figureImage shape: shapeImage</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>defaults</category>

<body package="ChemoJun-Catalog-Image" selector="defaultColumnSize">defaultColumnSize
	^3</body>

<body package="ChemoJun-Catalog-Image" selector="defaultWindowLabel">defaultWindowLabel
	^(#chemoJun_Molecular_Image_Catalog &gt;&gt; 'Molecular Image Catalog') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>displaying</category>

<body package="ChemoJun-Catalog-Image" selector="backgroundColor">backgroundColor
	^ColorValue 
		scaledRed: 7700
		scaledGreen: 7700
		scaledBlue: 7700</body>

<body package="ChemoJun-Catalog-Image" selector="clearAndRedisplay">clearAndRedisplay
	self changed: #clearAndRedisplay.
	self updateMenuIndication</body>

<body package="ChemoJun-Catalog-Image" selector="displayElement:index:into:">displayElement: element index: index into: aPixmap 
	^self 
		displayElement: element
		index: index
		into: aPixmap
		selectionColor: self selectionColor
		backgroundColor: self backgroundColor</body>

<body package="ChemoJun-Catalog-Image" selector="displayElement:index:into:selectionColor:backgroundColor:">displayElement: element index: index into: aPixmap selectionColor: selectionColor backgroundColor: backgroundColor 
	| pixmapContext |
	pixmapContext := aPixmap graphicsContext.
	pixmapContext paint: ColorValue white.
	pixmapContext displayRectangle: aPixmap bounds.
	self 
		displaySelection: element
		pixmapOn: pixmapContext
		selectionColor: selectionColor
		backgroundColor: backgroundColor.
	self displayElement: element pixmapOn: pixmapContext.
	self displayName: element pixmapOn: pixmapContext.
	self displayIndex: index pixmapOn: pixmapContext.
	^aPixmap</body>

<body package="ChemoJun-Catalog-Image" selector="displayElement:pixmapOn:">displayElement: element pixmapOn: pixmapContext 
	element thumbnail ifNil: 
			[pixmapContext paint: element class defaultEmptyColor.
			pixmapContext 
				displayRectangle: (self selectionMargin extent: element extent)]
		ifNotNil: [:it | it displayOn: pixmapContext at: self selectionMargin]</body>

<body package="ChemoJun-Catalog-Image" selector="displayIndex:pixmapOn:">displayIndex: index pixmapOn: pixmapContext 
	| aStyle composedText aBox |
	self visibleCatalogIndex 
		ifTrue: 
			[aStyle := TextAttributes styleNamed: #small
						ifAbsent: [TextAttributes default].
			composedText := ComposedText withText: index printString style: aStyle.
			aBox := composedText bounds.
			aBox := aBox align: aBox topLeft
						with: pixmapContext medium bounds topLeft + self selectionMargin + (0 @ -3).
			pixmapContext paint: ColorValue blue.
			composedText displayOn: pixmapContext at: aBox origin]</body>

<body package="ChemoJun-Catalog-Image" selector="displayName:pixmapOn:">displayName: element pixmapOn: pixmapContext 
	| aString aStyle composedText howMany loopPredicate aBox |
	self visibleFileName 
		ifTrue: 
			[aString := element baseNameString.
			self chemoJunJapanese 
				ifTrue: 
					[(ChemoJunUtility japaneseMolfileName: element filename) 
						ifNotNil: [:japaneseMolfileName | aString := japaneseMolfileName]].
			aStyle := TextAttributes styleNamed: #default
						ifAbsent: [TextAttributes default].
			composedText := ComposedText withText: aString asText style: aStyle.
			howMany := 1.
			loopPredicate := 
					[composedText bounds width &gt; element extent x 
						and: [aString size - howMany &gt; 3]].
			[loopPredicate value] whileTrue: 
					[composedText := ComposedText 
								withText: (aString contractTo: aString size - howMany) asText
								style: aStyle.
					howMany := howMany + 1].
			aBox := composedText bounds.
			aBox := aBox align: aBox corner
						with: pixmapContext medium bounds corner - self selectionMargin + (0 @ 2).
			pixmapContext paint: ColorValue black.
			composedText displayOn: pixmapContext at: aBox origin]</body>

<body package="ChemoJun-Catalog-Image" selector="displayOn:">displayOn: graphicsContext 
	self 
		assert: [Pixmap extent: self pixmapExtent]
		do: 
			[:aPixmap | 
			self elements with: (1 to: self elements size)
				do: 
					[:element :index | 
					| box |
					box := element bounds expandedBy: self class defaultElementMargin.
					(box intersects: graphicsContext clippingBounds) 
						ifTrue: 
							[self 
								displayElement: element
								index: index
								into: aPixmap.
							aPixmap displayOn: graphicsContext
								at: element bounds origin - self selectionMargin]]]
		ensure: [:aPixmap | aPixmap close]</body>

<body package="ChemoJun-Catalog-Image" selector="displaySelection:pixmapOn:selectionColor:backgroundColor:">displaySelection: element pixmapOn: pixmapContext selectionColor: selectionColor backgroundColor: backgroundColor 
	(self selections includes: element) 
		ifTrue: [pixmapContext paint: selectionColor]
		ifFalse: [pixmapContext paint: backgroundColor].
	pixmapContext displayRectangle: pixmapContext medium bounds</body>

<body package="ChemoJun-Catalog-Image" selector="pixmapExtent">pixmapExtent
	| aBox |
	aBox := (Point zero extent: self elementExtent) 
				expandedBy: self selectionMargin.
	^aBox extent</body>

<body package="ChemoJun-Catalog-Image" selector="redisplay">redisplay
	self changed: #redisplay.
	self updateMenuIndication</body>

<body package="ChemoJun-Catalog-Image" selector="selectionColor">selectionColor
	^ColorValue red</body>

<body package="ChemoJun-Catalog-Image" selector="selectionMargin">selectionMargin
	^2 @ 2</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>interface opening</category>

<body package="ChemoJun-Catalog-Image" selector="catalogView">catalogView
	| aView |
	aView := self class defaultMolecueCatalogViewClass model: self.
	(aView controller)
		menuHolder: [self yellowButtonMenu];
		performer: self.
	^aView</body>

<body package="ChemoJun-Catalog-Image" selector="fitWindowSize">fitWindowSize
	| aWindow aView windowExtent viewExtent widgetExtent viewWidth |
	(aWindow := self getWindow) ifNil: [^nil].
	(aView := self getView) ifNil: [^nil].
	windowExtent := aWindow displayBox extent.
	viewExtent := aView bounds extent.
	widgetExtent := windowExtent - viewExtent.
	viewWidth := self class defaultElementMargin x * (self columnSize + 1) 
				+ (self elementExtent x * self columnSize).
	windowExtent := viewWidth @ viewExtent y + widgetExtent.
	windowExtent := windowExtent max: aWindow minimumSize.
	aWindow displayBox extent = windowExtent ifTrue: [^nil].
	aWindow displayBox: ((aWindow displayBox origin extent: windowExtent) 
				intersect: Screen default bounds)</body>

<body package="ChemoJun-Catalog-Image" selector="postOpenWith:">postOpenWith: aBuilder 
	super postOpenWith: aBuilder.
	self fitWindowSize</body>

<body package="ChemoJun-Catalog-Image" selector="setWindowLabel">setWindowLabel
	| aWindow aFilename aString |
	aWindow := self getWindow.
	aWindow isNil ifTrue: [^nil].
	aWindow model = self ifFalse: [^nil].
	self filename isNil ifTrue: [^aWindow label: self defaultWindowLabel].
	aFilename := self filename asFilename.
	aString := (Filename splitPath: aFilename asString) last.
	aWindow label: self defaultWindowLabel , ' [' , aString , ']'</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>keyboard</category>

<body package="ChemoJun-Catalog-Image" selector="keyboardDispatchTable">keyboardDispatchTable
	| aTable |
	aTable := Dictionary new.
	aTable add: #Left -&gt; [self scrollLeft].
	aTable add: #Right -&gt; [self scrollRight].
	aTable add: #Up -&gt; [self scrollUp].
	aTable add: #Down -&gt; [self scrollDown].
	^aTable</body>

<body package="ChemoJun-Catalog-Image" selector="keyboardDispathDebug">keyboardDispathDebug
	^false</body>

<body package="ChemoJun-Catalog-Image" selector="keyboardEvent:fromController:">keyboardEvent: event fromController: controller 
	| dispatchTable keyValue messageSelector |
	self keyboardDispathDebug 
		ifTrue: 
			[Transcript
				cr;
				show: event keyValue printString].
	controller isControlActive ifFalse: [^event].
	self getView ifNil: [^event].
	controller viewHasCursor ifFalse: [^event].
	dispatchTable := self keyboardDispatchTable.
	dispatchTable isNil ifTrue: [^event].
	keyValue := event keyValue.
	messageSelector := dispatchTable at: keyValue ifAbsent: [nil].
	((messageSelector isKindOf: Symbol) 
		and: [self respondsTo: messageSelector]) 
			ifTrue: 
				[self perform: messageSelector.
				^nil].
	(messageSelector isKindOf: BlockClosure) 
		ifTrue: 
			[messageSelector value.
			^nil].
	^event</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Image" selector="catalogElementsToLispList">catalogElementsToLispList
	| aList |
	aList := self lispCons.
	aList head: #catalogElements.
	self elements collect: [:element | aList add: element toLispList].
	^aList</body>

<body package="ChemoJun-Catalog-Image" selector="columnSizeToLispList">columnSizeToLispList
	| alist |
	alist := self lispCons.
	alist head: #columnSize.
	alist tail: self columnSize.
	^alist</body>

<body package="ChemoJun-Catalog-Image" selector="elementExtentToLispList">elementExtentToLispList
	| alist |
	alist := self lispCons.
	alist head: #elementExtent.
	alist tail: self elementExtent.
	^alist</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTableToLispList">preferenceTableToLispList
	| alist |
	alist := self lispCons.
	alist head: #preferenceTable.
	alist tail: self preferenceTable toLispList.
	^alist</body>

<body package="ChemoJun-Catalog-Image" selector="selectedElementsToLispList">selectedElementsToLispList
	| aList |
	aList := self lispCons.
	aList head: #selectedElements.
	self selections 
		collect: [:element | aList add: (self elements indexOf: element)].
	^aList</body>

<body package="ChemoJun-Catalog-Image" selector="toLispList">toLispList
	| aList |
	aList := self lispCons.
	aList head: self class name.
	aList add: self columnSizeToLispList.
	aList add: self elementExtentToLispList.
	aList add: self catalogElementsToLispList.
	self selections isEmpty 
		ifFalse: [aList add: self selectedElementsToLispList].
	self preferenceTable isEmpty 
		ifFalse: [aList add: self preferenceTableToLispList].
	^aList</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>menu accessing</category>

<body package="ChemoJun-Catalog-Image" selector="updateEditMenuIndication">updateEditMenuIndication
	| menuItem aMenu |
	menuItem := self menuItemLabeled: 'Edit' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #openMoleculeViewer ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[(self isEmpty or: [self selections isEmpty or: [self isAllVoidSelections]]) 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #removeElements ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[(self isEmpty or: [self selections isEmpty or: [self isAllVoidSelections]]) 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #selectAll ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[(self isEmpty or: [self isAllSelections]) 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]]]</body>

<body package="ChemoJun-Catalog-Image" selector="updateFileMenuIndication">updateFileMenuIndication
	| menuItem aMenu |
	menuItem := self menuItemLabeled: 'File' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #saveCatalog ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsCatalog ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsSDFile ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsImage ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsHTML ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]]]</body>

<body package="ChemoJun-Catalog-Image" selector="updateMenuIndication">updateMenuIndication
	self updateFileMenuIndication.
	self updateEditMenuIndication.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Catalog-Image" selector="updateViewMenuIndication">updateViewMenuIndication
	| menuItem aMenu |
	menuItem := self menuItemLabeled: 'View' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #toggleCatalogIndex ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self visibleCatalogIndex ifTrue: [menuItem beOn] ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #toggleFileName ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self visibleFileName ifTrue: [menuItem beOn] ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #arrangeColumnSize ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #condenseElements ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self hasVoidElement ifTrue: [menuItem enable] ifFalse: [menuItem disable]]]</body>

<body package="ChemoJun-Catalog-Image" selector="yellowButtonMenu">yellowButtonMenu
	self updateEditMenuIndication.
	^(self menuItemLabeled: 'Edit' inMenu: self menuBar) submenu</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>menu messages</category>

<body package="ChemoJun-Catalog-Image" selector="arrangeColumnSize">arrangeColumnSize
	| numberOfColumns aString |
	self isEmpty ifTrue: [^nil].
	numberOfColumns := self columnSize.
	aString := JunDialog 
				request: (#chemoJun_How_many_column_size_ &gt;&gt; 'How many column size?') 
						asString
				initialAnswer: numberOfColumns printString.
	(aString isNil or: [aString isEmpty]) ifTrue: [^nil].
	numberOfColumns := aString asNumber asInteger.
	numberOfColumns &lt; 1 ifTrue: [^nil].
	self 
		assert: [self selections]
		do: [self columnSize: numberOfColumns]
		ensure: [:savedSelections | self selections: savedSelections].
	self fitWindowSize</body>

<body package="ChemoJun-Catalog-Image" selector="condenseElements">condenseElements
	self 
		assert: [self selections]
		do: [self elements: (self elements select: [:element | element isNotVoid])]
		ensure: [:savedSelections | self selections: savedSelections].
	self clearAndRedisplay</body>

<body package="ChemoJun-Catalog-Image" selector="openCatalogElement:">openCatalogElement: element 
	^self openCatalogElement: element at: nil</body>

<body package="ChemoJun-Catalog-Image" selector="openCatalogElement:at:">openCatalogElement: element at: point 
	| viewer |
	viewer := nil.
	(element filename notNil and: [element filename exists]) 
		ifTrue: 
			[Cursor wait showWhile: 
					[viewer := element class defaultMoleculeViewerClass 
								fileName: element filename.
					viewer chemoJunJapanese: self chemoJunJapanese.
					element toPreferences: viewer.
					self getWindow ifNil: [viewer open]
						ifNotNil: 
							[:window | 
							| box |
							element viewerExtent 
								ifNil: [box := 0 @ 0 extent: self class defaultViewerExtent]
								ifNotNil: [:it | box := 0 @ 0 extent: it].
							point ifNil: [box := box align: box center with: window displayBox center]
								ifNotNil: [box := box align: box origin with: point].
							viewer openIn: box].
					element projectionTable ifNil: [viewer resetView]
						ifNotNil: [:it | viewer projectionTable: it].
					viewer cameraButton 
						compute: [:value | self pressedCameraButtonOf: element in: viewer].
					viewer beVisibleCameraButton]].
	^viewer</body>

<body package="ChemoJun-Catalog-Image" selector="openCatalogFile">openCatalogFile
	| aCatalog |
	aCatalog := self class request.
	aCatalog ifNil: [^nil].
	catalogElements := nil.
	self columnSize: aCatalog columnSize.
	self elementExtent: aCatalog elementExtent.
	self elements: aCatalog elements.
	self selections: aCatalog selections.
	self filename: aCatalog filename.
	self preferenceTable: aCatalog preferenceTable.
	self fitWindowSize ifNil: [self redisplay]
		ifNotNil: [self updateMenuIndication]</body>

<body package="ChemoJun-Catalog-Image" selector="openMoleculeViewer">openMoleculeViewer
	| collection point |
	self 
		assert: 
			[collection := OrderedCollection new.
			point := nil]
		do: 
			[self selections do: 
					[:element | 
					| viewer |
					viewer := self openCatalogElement: element at: point.
					viewer ifNil: [point := nil]
						ifNotNil: 
							[:it | 
							collection add: it.
							point := it getWindow displayBox origin translatedBy: 25 @ 25].
					(JunSensorUtility shiftDown or: [JunSensorUtility altDown]) ifTrue: [^nil]]]
		ensure: 
			[collection 
				do: [:each | each closeTogetherWhenShiftDownOrAltDown: collection]]</body>

<body package="ChemoJun-Catalog-Image" selector="openSDFile">openSDFile
	| aReader moleculeObjects aDirectory filenameCollection elementCollection |
	aReader := ChemoJunSdFileReader request.
	aReader isNil ifTrue: [^nil].
	(moleculeObjects := aReader moleculeObjects) isEmpty ifTrue: [^nil].
	aDirectory := (aReader fileName asString , '.sbd') asFilename.
	aDirectory exists ifFalse: [aDirectory makeDirectory].
	filenameCollection := OrderedCollection new: moleculeObjects size.
	moleculeObjects with: (1 to: moleculeObjects size)
		do: 
			[:moleculeObject :nth | 
			| aWriter aString aCollection aFilename |
			aWriter := ChemoJunMolFileWriter moleculeObject: moleculeObject.
			aFilename := (aDirectory 
						construct: aReader baseName , aReader extension , '.' , nth printString 
								, '.mol') 
							asFilename.
			aString := moleculeObject molfileHeaderBlock at: 2.
			(aString size &gt;= 10 and: [(aString copyFrom: 3 to: 10) = 'ChemoJun']) 
				ifTrue: 
					[aString := moleculeObject molfileHeaderBlock at: 1.
					aCollection := aReader separate: aString.
					(aCollection size = 3 
						and: [aCollection first = '-' and: [aCollection last = '-']]) 
							ifTrue: 
								[aFilename := (aDirectory construct: (aCollection at: 2) , '.mol') 
											asFilename]].
			aWriter fileName: aFilename.
			aWriter write.
			filenameCollection add: aFilename].
	elementCollection := self elementsFrom: filenameCollection.
	self class catalogProgress 
		doWithStopButton: [self elements: self elements , elementCollection].
	self redisplay</body>

<body package="ChemoJun-Catalog-Image" selector="removeElements">removeElements
	| selections elements |
	(selections := self selections) isEmpty ifTrue: [^nil].
	(JunDialog confirm: #jun_Really_remove_ &gt;&gt; 'Really remove?') 
		ifFalse: [^nil].
	elements := self elements 
				reject: [:element | selections includes: element].
	self elements: elements.
	self clearSelections.
	self clearAndRedisplay</body>

<body package="ChemoJun-Catalog-Image" selector="requestNewImageFilename">requestNewImageFilename
	"ChemoJunImageCatalog new requestNewImageFilename."

	| labels values menu message aFilename |
	labels := Array 
				with: (Array with: (#jun_Image_files &gt;&gt; 'Image files') asString).
	values := Array with: JunSystem defaultImageExtensionPatterns.
	menu := Menu labelList: labels values: values.
	message := #jun_Input_an_image_file_ &gt;&gt; 'Input an image file.' 
				expandMacrosWith: 'image'.
	aFilename := ChemoJunFileRequesterDialog 
				requestNewFilename: message
				initialFilename: self defaultBaseName , '.jpg'
				fileTypeMenu: menu
				initialFileType: values first.
	aFilename isNil ifTrue: [^nil].
	^aFilename</body>

<body package="ChemoJun-Catalog-Image" selector="reviseElementExtent">reviseElementExtent
	| extent aString aCollection width height |
	extent := self elementExtent.
	aString := JunDialog 
				request: (#chemoJun_Element_extent_ &gt;&gt; 'Element extent?') asString
				initialAnswer: extent printString.
	(aString isNil or: [aString isEmpty]) ifTrue: [^nil].
	aCollection := JunStringUtility separate: aString
				dividers: JunStringUtility separators , '@x,'.
	aCollection size &lt; 1 ifTrue: [^nil].
	width := aCollection first asNumber asInteger.
	aCollection size &lt; 2 
		ifTrue: [height := width]
		ifFalse: [height := aCollection last asNumber asInteger].
	((width between: 100 and: 400) and: [height between: 100 and: 400]) 
		ifFalse: 
			[JunDialog 
				warn: (#chemoJun__1s__should_be_value_between 
						&gt;&gt; '&lt;1s&gt; should be value between &lt;2s&gt; and &lt;3s&gt;.' 
							expandMacrosWith: (#chemoJun_Element_extent &gt;&gt; 'Element extent') asString
							with: (100 @ 100) printString
							with: (400 @ 400) printString).
			^nil].
	self 
		assert: [self selections]
		do: [self elementExtent: width @ height]
		ensure: [:savedSelections | self selections: savedSelections].
	self fitWindowSize</body>

<body package="ChemoJun-Catalog-Image" selector="saveAsCatalog">saveAsCatalog
	| labels values menu filename |
	self isEmpty ifTrue: [^nil].
	labels := Array with: (Array 
						with: (#chemoJun_Molecular_image_catalog_files 
								&gt;&gt; 'Molecular image catalog files') asString)
				with: (Array with: (#jun_All_files &gt;&gt; 'All files') asString).
	values := Array with: #('*.mic' '*.MIC') with: #('*').
	menu := Menu labelList: labels values: values.
	filename := ChemoJunFileRequesterDialog 
				requestNewFilename: (#chemoJun_Input_a_molecular_image_catalog_file_ 
						&gt;&gt; 'Input a molecular image catalog file.') asString
				initialFilename: self defaultBaseName , '.mic'
				fileTypeMenu: menu
				initialFileType: values first.
	filename isNil ifTrue: [^nil].
	self saveCatalogTo: filename.
	self filename: filename</body>

<body package="ChemoJun-Catalog-Image" selector="saveAsHTML">saveAsHTML
	| baseDirectory imageDirectory thumbnailDirectory aCollection aFilename |
	self isEmpty ifTrue: [^nil].
	baseDirectory := ChemoJunFileRequesterDialog 
				requestNewDirectory: (#jun_Input_a_directory_ &gt;&gt; 'Input a directory.') 
						asString
				initialFilename: self defaultBaseName.
	baseDirectory ifNil: [^nil].
	baseDirectory exists ifFalse: [baseDirectory makeDirectory].
	imageDirectory := baseDirectory construct: 'images'.
	imageDirectory exists ifFalse: [imageDirectory makeDirectory].
	thumbnailDirectory := baseDirectory construct: 'thumbnails'.
	thumbnailDirectory exists ifFalse: [thumbnailDirectory makeDirectory].
	aCollection := OrderedCollection new: self elements size.
	self elements with: (1 to: self elements size)
		do: 
			[:element :index | 
			| aString imageFilename thumbnailFilename |
			aString := index printString.
			8 - aString size timesRepeat: [aString := '0' , aString].
			aString := aString , '.jpg'.
			imageFilename := imageDirectory construct: aString.
			thumbnailFilename := thumbnailDirectory construct: aString.
			aCollection 
				add: element -&gt; (Array with: imageFilename with: thumbnailFilename)].
	aFilename := baseDirectory construct: 'index.html'.
	Cursor write showWhile: [self htmlTo: aFilename with: aCollection].
	JunURL browse: aFilename asURI asString</body>

<body package="ChemoJun-Catalog-Image" selector="saveAsImage">saveAsImage
	| aBoolean anImage aFilename |
	aBoolean := JunSensorUtility shiftDown or: [JunSensorUtility altDown].
	anImage := self asImage.
	anImage isNil ifTrue: [^nil].
	aBoolean 
		ifTrue: 
			[anImage := anImage convertToPalette: JunImageProcessor grayPalette256
						renderedBy: NearestPaint new].
	aFilename := self requestNewImageFilename.
	aFilename isNil ifTrue: [^nil].
	self writeImage: anImage to: aFilename.
	^anImage</body>

<body package="ChemoJun-Catalog-Image" selector="saveAsSDFile">saveAsSDFile
	| aWriter moleculeObjects |
	self elements isEmpty ifTrue: [^nil].
	aWriter := ChemoJunSdFileWriter 
				requestInitialFileName: self defaultBaseName , '.sdf'.
	aWriter isNil ifTrue: [^nil].
	moleculeObjects := self moleculeObjects.
	aWriter moleculeObjects: moleculeObjects.
	aWriter write.
	^aWriter</body>

<body package="ChemoJun-Catalog-Image" selector="saveCatalog">saveCatalog
	self isEmpty ifTrue: [^nil].
	self filename ifNil: [self saveAsCatalog]
		ifNotNil: [:it | self saveCatalogTo: it]</body>

<body package="ChemoJun-Catalog-Image" selector="saveCatalogTo:">saveCatalogTo: aFilename 
	self 
		assert: [aFilename asFilename writeStream]
		do: 
			[:aStream | 
			aStream
				nextPutAll: '%';
				cr.
			aStream
				nextPutAll: '%';
				space;
				nextPutAll: 'Molecular Image Catalog';
				space;
				nextPutAll: '(created by';
				space;
				nextPutAll: ChemoJunSystem system , ChemoJunSystem version;
				space;
				nextPutAll: 'at';
				space;
				nextPutAll: JunCalendarModel stringFromDateAndTime;
				nextPutAll: ')';
				cr.
			aStream
				nextPutAll: '%';
				cr.
			self toLispList saveOn: aStream]
		ensure: [:aStream | aStream close]</body>

<body package="ChemoJun-Catalog-Image" selector="selectAll">selectAll
	self selections: self elements.
	self redisplay</body>

<body package="ChemoJun-Catalog-Image" selector="selectDirectory">selectDirectory
	| directory catalog |
	directory := ChemoJunFileRequesterDialog requestDirectory.
	directory isNil ifTrue: [^nil].
	catalog := self class new directory: directory.
	self elements: self elements , catalog elements.
	self filename: catalog filename.
	self redisplay</body>

<body package="ChemoJun-Catalog-Image" selector="toggleCatalogIndex">toggleCatalogIndex
	self visibleCatalogIndex: self visibleCatalogIndex not.
	self redisplay</body>

<body package="ChemoJun-Catalog-Image" selector="toggleFileName">toggleFileName
	self visibleFileName: self visibleFileName not.
	self redisplay</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>preferences</category>

<body package="ChemoJun-Catalog-Image" selector="chemoJunJapanese">chemoJunJapanese
	^self preferenceTable at: #chemoJunJapanese ifAbsentPut: [false]</body>

<body package="ChemoJun-Catalog-Image" selector="chemoJunJapanese:">chemoJunJapanese: aBoolean 
	self preferenceTable at: #chemoJunJapanese put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Image" selector="multiSelections">multiSelections
	^self preferenceTable at: #multiSelections ifAbsentPut: [true]</body>

<body package="ChemoJun-Catalog-Image" selector="multiSelections:">multiSelections: aBoolean 
	self preferenceTable at: #multiSelections put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTable">preferenceTable
	preferenceTable ifNil: [preferenceTable := JunAttributeTable new].
	^preferenceTable</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTable:">preferenceTable: attributeTable 
	preferenceTable := attributeTable</body>

<body package="ChemoJun-Catalog-Image" selector="singleSelection">singleSelection
	^self multiSelections not</body>

<body package="ChemoJun-Catalog-Image" selector="singleSelection:">singleSelection: aBoolean 
	^self multiSelections: (aBoolean = true) not</body>

<body package="ChemoJun-Catalog-Image" selector="visibleCatalogIndex">visibleCatalogIndex
	^self preferenceTable at: #visibleCatalogIndex ifAbsentPut: [false]</body>

<body package="ChemoJun-Catalog-Image" selector="visibleCatalogIndex:">visibleCatalogIndex: aBoolean 
	self preferenceTable at: #visibleCatalogIndex put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Image" selector="visibleFileName">visibleFileName
	^self preferenceTable at: #visibleFileName ifAbsentPut: [true]</body>

<body package="ChemoJun-Catalog-Image" selector="visibleFileName:">visibleFileName: aBoolean 
	self preferenceTable at: #visibleFileName put: aBoolean = true</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>printing</category>

<body package="ChemoJun-Catalog-Image" selector="printOn:">printOn: aStream 
	self toLispList printOn: aStream</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>scrolling</category>

<body package="ChemoJun-Catalog-Image" selector="scrollDown">scrollDown
	self selections size = 1 
		ifTrue: 
			[| index down |
			index := self elements indexOf: self selection.
			down := OrderedCollection new.
			(index + self columnSize to: self elements size by: self columnSize) 
				do: [:i | down add: (self elements at: i)].
			index := index 
						+ (self columnSize * (down findFirst: [:element | element isNotVoid])).
			index &lt;= self elements size 
				ifTrue: 
					[| element |
					element := self elements at: index.
					self selection: element.
					self scrollFor: element.
					self redisplay]]
		ifFalse: 
			[self getView 
				ifNotNil: [:aView | aView scrollBy: 0 @ self scrollGrid y negated]]</body>

<body package="ChemoJun-Catalog-Image" selector="scrollFor:">scrollFor: element 
	self getView ifNotNil: 
			[:aView | 
			| elementBox viewBox mergeBox |
			elementBox := element bounds.
			viewBox := aView bounds.
			mergeBox := elementBox merge: viewBox.
			mergeBox = viewBox 
				ifFalse: 
					[| scrollAmount marginPoint |
					scrollAmount := aView scrollOffset negated.
					marginPoint := self class defaultElementMargin.
					elementBox top &lt; viewBox top 
						ifTrue: [scrollAmount := scrollAmount x @ (elementBox top - marginPoint y)].
					elementBox bottom &gt; viewBox bottom 
						ifTrue: 
							[scrollAmount := scrollAmount x 
										@ (elementBox bottom - viewBox height + marginPoint y)].
					elementBox left &lt; viewBox left 
						ifTrue: [scrollAmount := (elementBox left - marginPoint x) @ scrollAmount y].
					elementBox right &gt; viewBox right 
						ifTrue: 
							[scrollAmount := (elementBox right - viewBox width + marginPoint x) 
										@ scrollAmount y].
					scrollAmount := scrollAmount negated.
					aView scrollTo: scrollAmount]]</body>

<body package="ChemoJun-Catalog-Image" selector="scrollGrid">scrollGrid
	^self elementExtent + self class defaultElementMargin</body>

<body package="ChemoJun-Catalog-Image" selector="scrollLeft">scrollLeft
	self selections size = 1 
		ifTrue: 
			[| index left |
			index := self elements indexOf: self selection.
			left := (self elements copyFrom: 1 to: index - 1) reverse.
			index := index - (left findFirst: [:element | element isNotVoid]).
			index &gt; 0 
				ifTrue: 
					[| element |
					element := self elements at: index.
					self selection: element.
					self scrollFor: element.
					self redisplay]]
		ifFalse: 
			[self getView ifNotNil: [:aView | aView scrollBy: self scrollGrid x @ 0]]</body>

<body package="ChemoJun-Catalog-Image" selector="scrollRight">scrollRight
	self selections size = 1 
		ifTrue: 
			[| index right |
			index := self elements indexOf: self selection.
			right := self elements copyFrom: index + 1 to: self elements size.
			index := index + (right findFirst: [:element | element isNotVoid]).
			index &lt;= self elements size 
				ifTrue: 
					[| element |
					element := self elements at: index.
					self selection: element.
					self scrollFor: element.
					self redisplay]]
		ifFalse: 
			[self getView 
				ifNotNil: [:aView | aView scrollBy: self scrollGrid x negated @ 0]]</body>

<body package="ChemoJun-Catalog-Image" selector="scrollUp">scrollUp
	self selections size = 1 
		ifTrue: 
			[| index up |
			index := self elements indexOf: self selection.
			up := OrderedCollection new.
			(index - self columnSize to: 1 by: self columnSize negated) 
				do: [:i | up add: (self elements at: i)].
			index := index 
						- (self columnSize * (up findFirst: [:element | element isNotVoid])).
			index &gt; 0 
				ifTrue: 
					[| element |
					element := self elements at: index.
					self selection: element.
					self scrollFor: element.
					self redisplay]]
		ifFalse: 
			[self getView ifNotNil: [:aView | aView scrollBy: 0 @ self scrollGrid y]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>selecting</category>

<body package="ChemoJun-Catalog-Image" selector="addSelection:">addSelection: catalogElement 
	self selections: self selections , (Array with: catalogElement)</body>

<body package="ChemoJun-Catalog-Image" selector="clearSelections">clearSelections
	self selections: Array new</body>

<body package="ChemoJun-Catalog-Image" selector="removeSelection:">removeSelection: catalogElement 
	self selections: ((self selections copy)
				remove: catalogElement ifAbsent: [nil];
				yourself)</body>

<body package="ChemoJun-Catalog-Image" selector="selection">selection
	self selections isEmpty ifTrue: [^nil].
	^self selections last</body>

<body package="ChemoJun-Catalog-Image" selector="selection:">selection: element 
	element ifNil: [self selections: Array new]
		ifNotNil: [:it | self selections: (Array with: it)]</body>

<body package="ChemoJun-Catalog-Image" selector="selections">selections
	selectedElements ifNil: [selectedElements := OrderedCollection new].
	^selectedElements</body>

<body package="ChemoJun-Catalog-Image" selector="selections:">selections: elementCollection 
	| aSet |
	aSet := Set new: elementCollection size.
	selectedElements := elementCollection asOrderedCollection select: 
					[:element | 
					| aBoolean |
					aBoolean := (aSet includes: element) not 
								and: [element notNil and: [element isNotVoid]].
					aSet add: element.
					aBoolean yourself].
	selectedElements isEmpty 
		ifTrue: [self updateEditMenuIndication]
		ifFalse: [self redisplay]</body>

<body package="ChemoJun-Catalog-Image" selector="where:">where: aPoint 
	^self elements detect: [:element | element bounds containsPoint: aPoint]
		ifNone: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="which:">which: aPoint 
	^(self where: aPoint) ifNil: [nil]
		ifNotNil: [:element | element isVoid ifTrue: [nil] ifFalse: [element]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>testing</category>

<body package="ChemoJun-Catalog-Image" selector="hasVoidElement">hasVoidElement
	^(self elements detect: [:element | element isVoid] ifNone: [nil]) notNil</body>

<body package="ChemoJun-Catalog-Image" selector="isAllSelections">isAllSelections
	self selections isEmpty ifTrue: [^false].
	^(self elements reject: [:element | self selections includes: element]) 
		isEmpty</body>

<body package="ChemoJun-Catalog-Image" selector="isAllVoidSelections">isAllVoidSelections
	self selections isEmpty ifTrue: [^false].
	^(self selections select: [:element | element isNotVoid]) isEmpty</body>

<body package="ChemoJun-Catalog-Image" selector="isEmpty">isEmpty
	^self elements ifNil: [true] ifNotNil: [:it | it isEmpty]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>utilities</category>

<body package="ChemoJun-Catalog-Image" selector="directories:">directories: directoryFilenames 
	| filenameCollection elementCollection |
	filenameCollection := OrderedCollection new.
	directoryFilenames do: 
			[:each | 
			| directoryName |
			directoryName := each asFilename.
			(directoryName exists and: [directoryName isDirectory]) 
				ifTrue: 
					[filenameCollection addAll: (JunFileModel 
								dive: directoryName
								level: 1
								patterns: #('*.mol' '*.MOL'))]].
	elementCollection := self elementsFrom: filenameCollection.
	self class catalogProgress 
		doWithStopButton: [self elements: elementCollection]</body>

<body package="ChemoJun-Catalog-Image" selector="directory:">directory: directoryFilename 
	^self directories: (Array with: directoryFilename)</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id> <category>private</category>

<body package="ChemoJun-Catalog-Image" selector="elementsFrom:">elementsFrom: filenameCollection 
	| elementCollection |
	elementCollection := OrderedCollection new: filenameCollection size.
	filenameCollection do: 
			[:aFilename | 
			| anElement |
			aFilename ifNil: [anElement := self class defaultCatalogElementClass new]
				ifNotNil: 
					[anElement := self class defaultCatalogElementClass filename: aFilename].
			elementCollection add: anElement].
	^elementCollection</body>

<body package="ChemoJun-Catalog-Image" selector="getView">getView
	| aView |
	aView := self dependents detect: 
					[:each | 
					(each isKindOf: self class defaultMolecueCatalogViewClass) 
						and: [each model = self]]
				ifNone: [nil].
	aView isNil ifTrue: [^nil].
	^aView</body>

<body package="ChemoJun-Catalog-Image" selector="htmlTo:with:">htmlTo: aFilename with: aCollection 
	JunProgress new do: 
			[:progress | 
			aCollection with: (1 to: aCollection size)
				do: 
					[:assoc :index | 
					| element filename |
					element := assoc key.
					progress message: element baseNameString.
					filename := assoc value last asFilename.
					self 
						assert: [JunJpegImageStream on: filename writeStream]
						do: 
							[:stream | 
							Cursor write showWhile: 
									[(element isVoid or: [element thumbnail isNil]) 
										ifTrue: [stream nextPutImage: element defaultThumbnail]
										ifFalse: [stream nextPutImage: element thumbnail asImage]]]
						ensure: [:stream | stream close].
					filename := assoc value first asFilename.
					self 
						assert: [JunJpegImageStream on: filename writeStream]
						do: 
							[:stream | 
							Cursor write showWhile: 
									[(element isVoid or: [element thumbnail isNil]) 
										ifTrue: [stream nextPutImage: element defaultImage]
										ifFalse: [stream nextPutImage: element image asImage]]]
						ensure: [:stream | stream close].
					progress value: index / aCollection size].
			self 
				assert: [aFilename writeStream]
				do: 
					[:aStream | 
					aStream 
						nextPutAll: '&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"&gt;
&lt;html lang="ja"&gt;
&lt;head&gt;
&lt;meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS"&gt;
&lt;meta http-equiv="Content-Style-Type" content="text/css"&gt;
&lt;link rev="made" href="mailto:cheminfo@nii.ac.jp"&gt;
&lt;link rel="index" href="index.html"&gt;
&lt;title&gt;Molecular Catalog&lt;/title&gt;
&lt;style type="text/css"&gt;
&lt;!--
body {
  background-color : #ffffff;
  margin : 20px;
  padding : 10px;
  font-family : serif;
  font-size : 10pt;
}
img.borderless {
  border-width : 0px;
  vertical-align : middle;
}
table.belt {
  border-style : solid;
  border-width : 0px;
  border-color : #000000;
  background-color : #cccccc;
  padding : 0px 0px;
}
table.content {
  border-style : solid;
  border-width : 0px;
  border-color : #000000;
  padding : 2px 4px;
}
table.element {
  border-style : solid;
  border-width : 0px;
  border-color : #000000;
  padding : 0px 0px;
}
td.element {
  text-align : right;
  font-size : 8pt;
  padding : 0px 0px;
  background-color : #ffffff;
}
td.center-small-white {
  text-align : center;
  font-size : 8pt;
  padding : 0px 0px;
  background-color : #ffffff;
}
td.left-small-white {
  text-align : left;
  font-size : 8pt;
  padding : 0px 0px;
  background-color : #ffffff;
}
td.right-small-white {
  text-align : right;
  font-size : 8pt;
  padding : 0px 0px;
  background-color : #ffffff;
}
--&gt;
&lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;table class="belt" summary="belt"&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;td&gt;
      &lt;table class="content" summary="content"&gt;
        &lt;tbody&gt;
'.
					10 timesRepeat: [aStream space].
					aStream nextPutAll: '&lt;tr&gt;'.
					aStream cr.
					aCollection with: (1 to: aCollection size)
						do: 
							[:assoc :index | 
							| element image thumbnail alt |
							element := assoc key.
							image := (Filename splitPath: assoc value first asString) last.
							thumbnail := (Filename splitPath: assoc value last asString) last.
							alt := (Filename splitExtension: thumbnail) first.
							12 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;td class="element"&gt;'.
							aStream cr.
							12 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;table class="element" summary="element"&gt;'.
							aStream cr.
							14 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;tbody&gt;'.
							aStream cr.
							self visibleCatalogIndex 
								ifTrue: 
									[16 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;tr&gt;'.
									aStream cr.
									18 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;td class="left-small-white"&gt;'.
									aStream nextPutAll: index printString.
									aStream nextPutAll: '&lt;/td&gt;'.
									aStream cr.
									16 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;/tr&gt;'.
									aStream cr].
							16 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;tr&gt;'.
							aStream cr.
							18 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;td class="center-small-white"&gt;'.
							aStream nextPutAll: '&lt;a href="images/'.
							aStream nextPutAll: image.
							aStream nextPutAll: '"&gt;'.
							aStream nextPutAll: '&lt;img class="borderless" src="thumbnails/'.
							aStream nextPutAll: thumbnail.
							aStream nextPutAll: '" width="'.
							aStream nextPutAll: element extent x printString.
							aStream nextPutAll: '" height="'.
							aStream nextPutAll: element extent y printString.
							aStream nextPutAll: '" alt="'.
							aStream nextPutAll: alt.
							aStream nextPutAll: '"&gt;'.
							aStream nextPutAll: '&lt;/a&gt;'.
							aStream nextPutAll: '&lt;/td&gt;'.
							aStream cr.
							16 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;/tr&gt;'.
							aStream cr.
							self visibleFileName 
								ifTrue: 
									[16 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;tr&gt;'.
									aStream cr.
									18 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;td class="right-small-white"&gt;'.
									element baseNameString isEmpty 
										ifTrue: [aStream nextPutAll: '&amp;nbsp;']
										ifFalse: [aStream nextPutAll: element baseNameString].
									aStream nextPutAll: '&lt;/td&gt;'.
									aStream cr.
									16 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;/tr&gt;'.
									aStream cr].
							14 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;/tbody&gt;'.
							aStream cr.
							12 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;/table&gt;'.
							aStream cr.
							12 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;/td&gt;'.
							aStream cr.
							(index \\ columnSize = 0 and: [index ~= aCollection size]) 
								ifTrue: 
									[10 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;/tr&gt;'.
									aStream cr.
									10 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;tr&gt;'.
									aStream cr]].
					10 timesRepeat: [aStream space].
					aStream nextPutAll: '&lt;/tr&gt;'.
					aStream cr.
					aStream 
						nextPutAll: '        &lt;/tbody&gt;
      &lt;/table&gt;
      &lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;
&lt;/body&gt;
&lt;/html&gt;']
				ensure: [:aStream | aStream close]]</body>
</methods>

<initialize>
<class-id>ChemoJun.ChemoJunImageCatalog</class-id>
</initialize>


</st-source>
