<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76985 "21:23:05"))'</do-it>



<class>
<name>ChemoJunMolFileReader</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunAbstractFileReader</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>numberOfAtoms numberOfConnections atomList connectionList </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-File-IO</category>
<attributes>
<package>ChemoJun-File-IO</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunMolFileReader class</class-id> <category>copyright</category>

<body package="ChemoJun-File-IO" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-File-IO" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-File-IO" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileReader class</class-id> <category>defaults</category>

<body package="ChemoJun-File-IO" selector="defaultAtomConnectionClass">defaultAtomConnectionClass
	^ChemoJunAtomConnection</body>

<body package="ChemoJun-File-IO" selector="defaultFileDescriptions">defaultFileDescriptions
	^Array with: (Array 
				with: (#chemoJun_Molecular_structure_files &gt;&gt; 'Molecular structure files') 
						asString)
		with: (Array with: (#jun_All_files &gt;&gt; 'All files') asString)</body>

<body package="ChemoJun-File-IO" selector="defaultFilePatterns">defaultFilePatterns
	^Array with: #('*.mol' '*.MOL') with: #('*')</body>

<body package="ChemoJun-File-IO" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^ChemoJunMoleculeObject</body>

<body package="ChemoJun-File-IO" selector="defaultRequestMessageString">defaultRequestMessageString
	^(#chemoJun_Select_a_molecular_file_ &gt;&gt; 'Select a molecular file.') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileReader class</class-id> <category>examples</category>

<body package="ChemoJun-File-IO" selector="example1">example1
	"ChemoJunMolFileReader example1."

	| aReader |
	aReader := ChemoJunMolFileReader request.
	aReader isNil ifTrue: [^nil].
	^aReader</body>

<body package="ChemoJun-File-IO" selector="example2">example2
	"ChemoJunMolFileReader example2."

	| aReader |
	aReader := ChemoJunMolFileReader request.
	aReader isNil ifTrue: [^nil].
	(ChemoJunMoleculeViewer moleculeObject: aReader moleculeObject) open</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunMolFileReader</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunMolFileReader</class-id> <category>initialize-release</category>

<body package="ChemoJun-File-IO" selector="initialize">initialize
	super initialize.
	numberOfAtoms := nil.
	numberOfConnections := nil.
	atomList := nil.
	connectionList := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileReader</class-id> <category>accessing</category>

<body package="ChemoJun-File-IO" selector="atomList">atomList
	atomList isNil ifTrue: [atomList := OrderedCollection new].
	^atomList</body>

<body package="ChemoJun-File-IO" selector="connectionList">connectionList
	connectionList isNil ifTrue: [connectionList := OrderedCollection new].
	^connectionList</body>

<body package="ChemoJun-File-IO" selector="moleculeObject">moleculeObject
	^self class defaultMoleculeObjectClass fromReader: self</body>

<body package="ChemoJun-File-IO" selector="numberOfAtoms">numberOfAtoms
	numberOfAtoms isNil ifTrue: [numberOfAtoms := 0].
	^numberOfAtoms</body>

<body package="ChemoJun-File-IO" selector="numberOfConnections">numberOfConnections
	numberOfConnections isNil ifTrue: [numberOfConnections := 0].
	^numberOfConnections</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileReader</class-id> <category>defaults</category>

<body package="ChemoJun-File-IO" selector="defaultAtomObjectClass">defaultAtomObjectClass
	^self class defaultAtomObjectClass</body>

<body package="ChemoJun-File-IO" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^self class defaultMoleculeObjectClass</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileReader</class-id> <category>obsolete</category>

<body package="ChemoJun-File-IO" selector="obosolete_readHeaderBlockFrom:">obosolete_readHeaderBlockFrom: aStream 
	| boolean position line collection |
	boolean := true.
	position := aStream position.
	[aStream atEnd not and: [boolean]] whileTrue: 
			[line := self getLine: aStream.
			collection := self separate: line dividers: self separators , 'Vv'.
			(collection size &gt;= 2 and: 
					[((collection at: 1) detect: [:c | c isDigit not] ifNone: [nil]) isNil 
						and: [((collection at: 2) detect: [:c | c isDigit not] ifNone: [nil]) isNil]]) 
				ifTrue: [boolean := false]
				ifFalse: [self commentList add: line].
			position := aStream position].
	aStream position: position</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileReader</class-id> <category>reading</category>

<body package="ChemoJun-File-IO" selector="readAtomBlockFrom:">readAtomBlockFrom: aStream 
	numberOfAtoms timesRepeat: 
			[| line size string x y z atom point |
			line := self getLine: aStream.
			size := line size.
			string := line copyFrom: (1 min: size) to: (10 min: size).
			x := (string , 'd') asNumber.
			string := line copyFrom: (11 min: size) to: (20 min: size).
			y := (string , 'd') asNumber.
			string := line copyFrom: (21 min: size) to: (30 min: size).
			z := (string , 'd') asNumber.
			string := line copyFrom: (32 min: size) to: (34 min: size).
			[string first isSeparator] 
				whileTrue: [string := string copyFrom: 2 to: string size].
			[string last isSeparator] 
				whileTrue: [string := string copyFrom: 1 to: string size - 1].
			atom := string.
			point := x , y , z.
			self atomList add: (Array with: atom with: point)]</body>

<body package="ChemoJun-File-IO" selector="readBondBlockFrom:">readBondBlockFrom: aStream 
	numberOfConnections timesRepeat: 
			[| line size string from to bond stereo |
			line := self getLine: aStream.
			size := line size.
			string := line copyFrom: (1 min: size) to: (3 min: size).
			from := string asNumber.
			string := line copyFrom: (4 min: size) to: (6 min: size).
			to := string asNumber.
			string := line copyFrom: (7 min: size) to: (9 min: size).
			bond := string asNumber.
			string := line copyFrom: (10 min: size) to: (12 min: size).
			stereo := string asNumber.
			self connectionList add: (Array 
						with: from
						with: to
						with: bond
						with: stereo)]</body>

<body package="ChemoJun-File-IO" selector="readCountsLineFrom:">readCountsLineFrom: aStream 
	| line string |
	line := self getLine: aStream.
	string := line copyFrom: 1 to: 3.
	numberOfAtoms := string asNumber max: 0.
	string := line copyFrom: 4 to: 6.
	numberOfConnections := string asNumber max: 0</body>

<body package="ChemoJun-File-IO" selector="readFrom:">readFrom: aStream 
	commentList := OrderedCollection new.
	numberOfAtoms := 0.
	numberOfConnections := 0.
	atomList := nil.
	connectionList := nil.
	self readHeaderBlockFrom: aStream.
	self readCountsLineFrom: aStream.
	self readAtomBlockFrom: aStream.
	self readBondBlockFrom: aStream.
	self readPropertiesBlockFrom: aStream</body>

<body package="ChemoJun-File-IO" selector="readHeaderBlockFrom:">readHeaderBlockFrom: aStream 
	| count line |
	count := 1.
	[aStream atEnd not and: [count &lt;= 3]] whileTrue: 
			[line := self getLine: aStream.
			self commentList add: line.
			count := count + 1]</body>

<body package="ChemoJun-File-IO" selector="readPropertiesBlockFrom:">readPropertiesBlockFrom: aStream 
	[aStream atEnd not] whileTrue: 
			[| aString aCollection |
			aString := self getLine: aStream.
			aCollection := self separate: aString.
			(aCollection size &gt;= 2 
				and: [(aCollection at: 1) = 'M' and: [(aCollection at: 2) = 'END']]) 
					ifTrue: [^self]].
	^self</body>
</methods>


</st-source>
