<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76977 "21:22:57"))'</do-it>



<class>
<name>ChemoJunMoleculeViewer</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunAbstractViewer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>moleculeObject messageSymbol exceptHydrogen exceptIndex indexExpression indexExpressionBlock cameraButton </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Display-Viewer</category>
<attributes>
<package>ChemoJun-Display-Viewer</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer class</class-id> <category>instance creation</category>

<body package="ChemoJun-Display-Viewer" selector="fileName:">fileName: moleculeFilename 
	^self 
		moleculeObject: (self defaultMoleculeObjectClass fileName: moleculeFilename)</body>

<body package="ChemoJun-Display-Viewer" selector="moleculeObject:">moleculeObject: moleculeObject 
	^(self new)
		moleculeObject: moleculeObject;
		exceptHydrogen: moleculeObject exceptHydrogen;
		yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer class</class-id> <category>copyright</category>

<body package="ChemoJun-Display-Viewer" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Display-Viewer" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Display-Viewer" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer class</class-id> <category>defaults</category>

<body package="ChemoJun-Display-Viewer" selector="defaultExceptSerialNumber">defaultExceptSerialNumber
	^true</body>

<body package="ChemoJun-Display-Viewer" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^ChemoJunMoleculeObject</body>

<body package="ChemoJun-Display-Viewer" selector="defaultMolFileReaderClass">defaultMolFileReaderClass
	^ChemoJunMolFileReader</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer class</class-id> <category>examples</category>

<body package="ChemoJun-Display-Viewer" selector="example1">example1
	"ChemoJunMoleculeViewer example1."

	| aViewer |
	aViewer := ChemoJunMoleculeViewer new.
	aViewer open.
	^aViewer</body>

<body package="ChemoJun-Display-Viewer" selector="example2">example2
	"ChemoJunMoleculeViewer example2."

	| fileName originalMolecule originalViewer |
	fileName := './CastData/ABC-88-52-211-1.2D.mol'.
	originalMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	originalViewer := ChemoJunMoleculeViewer moleculeObject: originalMolecule.
	originalViewer messageSymbol: #moleculeAsPlane.
	originalViewer openIn: (100 @ 200 extent: 600 @ 300).
	^originalViewer</body>

<body package="ChemoJun-Display-Viewer" selector="example3">example3
	"ChemoJunMoleculeViewer example3."

	| fileName originalMolecule originalViewer modifiedMolecule modifiedViewer aCollection |
	fileName := './ChemoJunSampleData/fullerene_expanded.mol'.
	originalMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	originalViewer := ChemoJunMoleculeViewer moleculeObject: originalMolecule.
	originalViewer showMoleculeAsPlane.
	originalViewer openIn: (100 @ 200 extent: 600 @ 300).
	modifiedMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	modifiedMolecule 
		changeColor: ColorValue red
		serialNumbers: #(8 9)
		nestLevel: 0.
	modifiedViewer := ChemoJunMoleculeViewer moleculeObject: modifiedMolecule.
	modifiedViewer showMoleculeAsPlane.
	modifiedViewer openIn: (100 @ 550 extent: 600 @ 300).
	aCollection := Array with: originalViewer with: modifiedViewer.
	aCollection do: [:each | each closeTogether: aCollection].
	^aCollection</body>

<body package="ChemoJun-Display-Viewer" selector="example4">example4
	"ChemoJunMoleculeViewer example4."

	| fileName originalMolecule originalViewer modifiedMolecule modifiedViewer aCollection |
	fileName := './ChemoJunSampleData/fullerene.mol'.
	originalMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	originalViewer := ChemoJunMoleculeViewer moleculeObject: originalMolecule.
	originalViewer showMoleculeAsBallAndStick.
	originalViewer openIn: (100 @ 200 extent: 600 @ 300).
	modifiedMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	modifiedMolecule 
		changeColor: ColorValue red
		serialNumbers: #(8 9)
		nestLevel: 0.
	modifiedViewer := ChemoJunMoleculeViewer moleculeObject: modifiedMolecule.
	modifiedViewer showMoleculeAsBallAndStick.
	modifiedViewer openIn: (100 @ 550 extent: 600 @ 300).
	aCollection := Array with: originalViewer with: modifiedViewer.
	aCollection do: [:each | each closeTogether: aCollection].
	^aCollection</body>

<body package="ChemoJun-Display-Viewer" selector="example5">example5
	"ChemoJunMoleculeViewer example5."

	| fileName originalMolecule originalViewer modifiedMolecule modifiedViewer aCollection |
	fileName := './ChemoJunSampleData/fullerene_expanded.mol'.
	originalMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	originalViewer := ChemoJunMoleculeViewer moleculeObject: originalMolecule.
	originalViewer showMoleculeAsPlane.
	originalViewer openIn: (100 @ 200 extent: 600 @ 300).
	modifiedMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	modifiedMolecule 
		changeColor: ColorValue red
		serialNumberPairs: #(#(8 4) #(7 17))
		nestLevel: 1.
	modifiedViewer := ChemoJunMoleculeViewer moleculeObject: modifiedMolecule.
	modifiedViewer showMoleculeAsPlane.
	modifiedViewer openIn: (100 @ 550 extent: 600 @ 300).
	aCollection := Array with: originalViewer with: modifiedViewer.
	aCollection do: [:each | each closeTogether: aCollection].
	^aCollection</body>

<body package="ChemoJun-Display-Viewer" selector="example6">example6
	"ChemoJunMoleculeViewer example6."

	| fileName originalMolecule originalViewer modifiedMolecule modifiedViewer aCollection |
	fileName := './ChemoJunSampleData/fullerene.mol'.
	originalMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	originalViewer := ChemoJunMoleculeViewer moleculeObject: originalMolecule.
	originalViewer showMoleculeAsBallAndStick.
	originalViewer openIn: (100 @ 200 extent: 600 @ 300).
	modifiedMolecule := ChemoJunMoleculeObject 
				fileName: (JunUniFileName named: fileName).
	modifiedMolecule 
		changeColor: ColorValue red
		serialNumberPairs: #(#(22 35) #(34 37))
		nestLevel: 0.
	modifiedViewer := ChemoJunMoleculeViewer moleculeObject: modifiedMolecule.
	modifiedViewer showMoleculeAsBallAndStick.
	modifiedViewer openIn: (100 @ 550 extent: 600 @ 300).
	aCollection := Array with: originalViewer with: modifiedViewer.
	aCollection do: [:each | each closeTogether: aCollection].
	^aCollection</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer class</class-id> <category>interface specs</category>

<body package="ChemoJun-Display-Viewer" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 
			#(#{Kernel.UserMessage} 
				#key: #chemoJun_Molecular_Viewer 
				#defaultString: 'Molecular Viewer' ) 
			#min: #(#{Core.Point} 280 280 ) 
			#bounds: #(#{Graphics.Rectangle} 512 280 812 580 ) 
			#flags: 4 
			#menu: #menuBar ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} 1 0 1 0 -20 1 -1 1 ) 
					#name: #displayView 
					#colors: 
					#(#{UI.LookPreferences} 
						#setBackgroundColor: #(#{Graphics.ColorValue} #white ) ) 
					#component: #displayView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} -19 1 1 0 -1 1 19 0 ) 
					#name: #pickButtonView 
					#flags: 0 
					#component: #pickButtonView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} -19 1 20 0 -1 1 38 0 ) 
					#name: #grabButtonView 
					#flags: 0 
					#component: #grabButtonView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} -19 1 39 0 -1 1 57 0 ) 
					#name: #dragButtonView 
					#flags: 0 
					#component: #dragButtonView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} -19 1 -61 0.5 -1 1 61 0.5 ) 
					#name: #zThumbWheelView 
					#flags: 0 
					#component: #zThumbWheelView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} -19 1 62 0.5 -1 1 80 0.5 ) 
					#name: #focusButtonView 
					#flags: 0 
					#component: #focusButtonView ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} -19 1 -38 1 -1 1 -20 1 ) 
					#name: #cameraButtonView 
					#flags: 48 
					#component: #cameraButtonView ) ) ) )</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer class</class-id> <category>resources</category>

<body package="ChemoJun-Display-Viewer" selector="menuBar">menuBar
	"Tools.MenuEditor new openOnClass: self andSelector: #menuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_File 
					#defaultString: 'File' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_New 
								#defaultString: 'New' ) 
							#value: #newModel ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Open 
								#defaultString: 'Open' ) 
							#value: #openMolecule ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as 
								#defaultString: 'Save as' ) 
							#value: #saveAsFile ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_Image 
								#defaultString: 'Save as Image' ) 
							#value: #saveAsImage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Quit 
								#defaultString: 'Quit' ) 
							#value: #quitDoing ) ) #(2 2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_View 
					#defaultString: 'View' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_2D 
								#defaultString: '2D' ) 
							#value: #showMoleculeAsPlane ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Sticks 
								#defaultString: 'Sticks' ) 
							#value: #showMoleculeAsStick ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Ball_and_Stick 
								#defaultString: 'Ball &amp;&amp; Stick' ) 
							#value: #showMoleculeAsBallAndStick ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Space_Filling 
								#defaultString: 'Space Filling' ) 
							#value: #showMoleculeAsSpaceFill ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Stick_and_Space_Filling 
								#defaultString: 'Stick &amp;&amp; Space Filling' ) 
							#value: #showMoleculeAsStickAndSpaceFill ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Show_Hydrogens 
								#defaultString: 'Hydrogens' ) 
							#value: #toggleHydrogen ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Show_Serial_Nos__of_Atoms 
								#defaultString: 'Serial Nos. of Atoms' ) 
							#value: #toggleIndex ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Setting_Serial_Nos_ 
								#defaultString: 'Setting Serial Nos.' ) 
							#value: #settingIndex ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Low_Resolution 
								#defaultString: 'Low Resolution' ) 
							#value: #lowResolution ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Medium_Resolution 
								#defaultString: 'Medium Resolution' ) 
							#value: #mediumResolution ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_High_Resolution 
								#defaultString: 'High Resolution' ) 
							#value: #highResolution ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Reset 
								#defaultString: 'Reset' ) 
							#value: #resetView ) ) #(5 3 3 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Misc 
					#defaultString: 'Misc' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Manual 
								#defaultString: 'Manual' ) 
							#value: #browseManual ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Information 
								#defaultString: 'Information' ) 
							#value: #showInformation ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Viewfinder 
								#defaultString: 'Viewfinder' ) 
							#value: #spawnObject ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Viewport 
								#defaultString: 'Viewport' ) 
							#value: #spawnViewport ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Inspect 
								#defaultString: 'Inspect' ) 
							#value: #inspectModel ) ) #(1 1 2 1 ) nil ) ) ) #(3 ) nil ) decodeAsLiteralArray</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>initialize-release</category>

<body package="ChemoJun-Display-Viewer" selector="initialize">initialize
	super initialize.
	moleculeObject := nil.
	messageSymbol := nil.
	exceptHydrogen := ChemoJunMoleculeObject defaultExceptHydrogen.
	exceptIndex := self class defaultExceptSerialNumber.
	indexExpression := nil.
	indexExpressionBlock := nil.
	cameraButton := nil.
	self 
		superimposeBlock: [:model :view :controller | self displaySuperimposeInView: view]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>accessing</category>

<body package="ChemoJun-Display-Viewer" selector="atomConnections">atomConnections
	^self moleculeObject ifNil: [Array new]
		ifNotNil: [:it | it atomConnections]</body>

<body package="ChemoJun-Display-Viewer" selector="atomObjects">atomObjects
	^self moleculeObject ifNil: [Array new] ifNotNil: [:it | it atomObjects]</body>

<body package="ChemoJun-Display-Viewer" selector="averageLengthOfConnections">averageLengthOfConnections
	^self moleculeObject ifNil: [0]
		ifNotNil: [:it | it averageLengthOfConnections]</body>

<body package="ChemoJun-Display-Viewer" selector="displayObject">displayObject
	| theMolecule |
	(displayObject isNil and: [(theMolecule := self moleculeObject) notNil]) 
		ifTrue: 
			[Cursor wait showWhile: 
					[self displayObject: (theMolecule perform: self messageSymbol).
					self displayObject boundingBox.
					self informationHolder value: self informationString]].
	^displayObject</body>

<body package="ChemoJun-Display-Viewer" selector="exceptHydrogen">exceptHydrogen
	^exceptHydrogen = true</body>

<body package="ChemoJun-Display-Viewer" selector="exceptHydrogen:">exceptHydrogen: aBoolean 
	self 
		assert: [self exceptHydrogen]
		do: 
			[exceptHydrogen := aBoolean = true.
			self moleculeObject notNil 
				ifTrue: [self moleculeObject exceptHydrogen: exceptHydrogen]]
		ensure: [:oldBoolean | oldBoolean = self exceptHydrogen ifFalse: [self flushDisplayObject]]</body>

<body package="ChemoJun-Display-Viewer" selector="exceptIndex">exceptIndex
	^exceptIndex = true</body>

<body package="ChemoJun-Display-Viewer" selector="exceptIndex:">exceptIndex: aBoolean 
	exceptIndex := aBoolean = true</body>

<body package="ChemoJun-Display-Viewer" selector="fileName">fileName
	| aFilename |
	self moleculeObject isNil ifTrue: [^nil].
	aFilename := self moleculeObject fileName asFilename.
	^aFilename</body>

<body package="ChemoJun-Display-Viewer" selector="informationString">informationString
	| aString |
	self moleculeObject isNil ifTrue: [^String new].
	self 
		assert: [String new writeStream]
		do: 
			[:aStream | 
			aStream 
				nextPutAll: (#chemoJun_Molecular_Information_ &gt;&gt; 'Molecular Information:') 
						asString.
			aStream cr.
			aStream nextPutAll: self moleculeObject informationString.
			aStream tab.
			aStream 
				nextPutAll: (#chemoJun_number_of_primitives__ &gt;&gt; 'number of primitives: ') 
						asString.
			aStream nextPutAll: self numberOfPrimitives printString.
			aStream cr.
			aString := aStream contents]
		ensure: [:aStream | aStream close].
	^aString</body>

<body package="ChemoJun-Display-Viewer" selector="messageSymbol">messageSymbol
	messageSymbol isNil ifTrue: [messageSymbol := self defaultMessageSymbol].
	^messageSymbol</body>

<body package="ChemoJun-Display-Viewer" selector="messageSymbol:">messageSymbol: aSymbol 
	((#(#moleculeAsStick #moleculeAsBallAndStick #moleculeAsSpaceFill #moleculeAsStickAndSpaceFill #moleculeAsPlane) 
		includes: aSymbol) and: [messageSymbol ~~ aSymbol]) 
		ifTrue: 
			[messageSymbol := aSymbol.
			self flushDisplayObject]</body>

<body package="ChemoJun-Display-Viewer" selector="moleculeObject">moleculeObject
	^moleculeObject</body>

<body package="ChemoJun-Display-Viewer" selector="moleculeObject:">moleculeObject: aMolecule 
	moleculeObject := aMolecule.
	aMolecule ifNotNil: 
			[aMolecule is2d ifTrue: [self messageSymbol: #moleculeAsPlane].
			(aMolecule is3d and: [self messageSymbol = #moleculeAsPlane]) 
				ifTrue: [self messageSymbol: self defaultMessageSymbol]].
	self flushDisplayObject</body>

<body package="ChemoJun-Display-Viewer" selector="moleculeText">moleculeText
	^ValueHolder with: 'xyz'</body>

<body package="ChemoJun-Display-Viewer" selector="numberOfAtoms">numberOfAtoms
	^self moleculeObject ifNil: [0] ifNotNil: [:it | it numberOfAtoms]</body>

<body package="ChemoJun-Display-Viewer" selector="serialNumberComposedText:">serialNumberComposedText: atomObject 
	| aBlock numberOfArguments serialNumber argumentArray |
	aBlock := self indexExpressionBlock.
	numberOfArguments := aBlock numArgs.
	serialNumber := atomObject serialNumber.
	argumentArray := (Array 
				with: serialNumber
				with: atomObject atomicSymbol
				with: atomObject atomicPoint
				with: atomObject) copyFrom: 1 to: numberOfArguments.
	((aBlock valueWithArguments: argumentArray) = true 
		and: [(atomObject isHydrogen and: [self exceptHydrogen]) not]) 
			ifTrue: 
				[atomObject displayComposedTextOfSerialNumber ifNil: 
						[| composedText |
						composedText := ComposedText withText: serialNumber printString asText
									style: self defaultStyleOfSerialNumber.
						atomObject displayComposedTextOfSerialNumber: composedText].
				^atomObject displayComposedTextOfSerialNumber].
	^nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>accessing modifiers</category>

<body package="ChemoJun-Display-Viewer" selector="modifierImage:">modifierImage: atomObject 
	^atomObject displayImageOfModifier</body>

<body package="ChemoJun-Display-Viewer" selector="modifierImage:fromAtom:toAtom:inView:">modifierImage: atomObject fromAtom: fromAtom toAtom: toAtom inView: aView 
	(self hasModifier: atomObject) 
		ifTrue: 
			[atomObject displayImageOfModifier ifNil: 
					[| fromPoint toPoint aPlane normalPresentation anAssociation anArray anImage aPoint |
					atomObject = toAtom 
						ifTrue: 
							[fromPoint := fromAtom atomicPoint.
							toPoint := toAtom atomicPoint]
						ifFalse: 
							[fromPoint := toAtom atomicPoint.
							toPoint := fromAtom atomicPoint].
					aPlane := self sightPoint plane: self sightPoint + self upVector
								and: self eyePoint.
					aPlane := aPlane translatedBy: fromPoint - self sightPoint.
					aPlane ifNil: [normalPresentation := true]
						ifNotNil: [:plane | normalPresentation := (plane whichSide: toPoint) &gt;= 0].
					anAssociation := self moleculeObject modifierAssociation: atomObject
								normalPresentation: normalPresentation.
					anArray := self convertModifierStringToImage: anAssociation key
								focusAtomIndex: anAssociation value.
					anImage := anArray first.
					aPoint := anArray last.
					atomObject displayFocusAtomPointOfModifier: aPoint.
					atomObject displayImageOfModifier: anImage].
			^atomObject displayImageOfModifier].
	^nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>actions</category>

<body package="ChemoJun-Display-Viewer" selector="clickAt:">clickAt: mouse2dPoint 
	| pickedObject aProjection aPoint minimumDistance targetAtomObject targetSerialNumber aLine |
	self moleculeObject isNil ifTrue: [^nil].
	pickedObject := self pickedObjectAt: mouse2dPoint.
	pickedObject isNil ifTrue: [^nil].
	aProjection := self displayProjection.
	aPoint := aProjection translateTo3dPointFromPoint: mouse2dPoint.
	minimumDistance := nil.
	targetAtomObject := nil.
	targetSerialNumber := nil.
	aLine := (Jun3dLine from: aProjection eyePoint to: aProjection sightPoint) 
				translatedBy: aPoint - aProjection sightPoint.
	self atomObjectsAndIndexesDo: 
			[:atomObject :serialNumber | 
			| atomicPoint |
			atomicPoint := atomObject atomicPoint.
			minimumDistance isNil 
				ifTrue: 
					[minimumDistance := aLine distanceFromPoint: atomicPoint.
					targetAtomObject := atomObject.
					targetSerialNumber := serialNumber]
				ifFalse: 
					[minimumDistance &gt; (aLine distanceFromPoint: atomicPoint) 
						ifTrue: 
							[minimumDistance := aLine distanceFromPoint: atomicPoint.
							targetAtomObject := atomObject.
							targetSerialNumber := serialNumber]]].
	targetAtomObject isNil ifTrue: [^nil].
	^targetAtomObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>buttons</category>

<body package="ChemoJun-Display-Viewer" selector="beInvisibleCameraButton">beInvisibleCameraButton
	| specWrapper |
	(specWrapper := self cameraButtonSpecWrapper) isNil ifTrue: [^nil].
	specWrapper
		beInvisible;
		disable</body>

<body package="ChemoJun-Display-Viewer" selector="beVisibleCameraButton">beVisibleCameraButton
	| specWrapper |
	(specWrapper := self cameraButtonSpecWrapper) isNil ifTrue: [^nil].
	specWrapper
		beVisible;
		enable</body>

<body package="ChemoJun-Display-Viewer" selector="cameraButton">cameraButton
	cameraButton isNil 
		ifTrue: 
			[| image figure shape button |
			image := JunCursors cameraCursor asOpaqueImage.
			figure := image figure asImage.
			shape := image shape asImage.
			image := OpaqueImage figure: figure shape: shape.
			button := JunButtonModel 
						value: false
						visual: image
						action: [:model | model changed: #value].
			cameraButton := button].
	^cameraButton</body>

<body package="ChemoJun-Display-Viewer" selector="cameraButtonSpecWrapper">cameraButtonSpecWrapper
	| aBuilder |
	(aBuilder := self builder) isNil ifTrue: [^nil].
	^aBuilder componentAt: #cameraButtonView</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>computing</category>

<body package="ChemoJun-Display-Viewer" selector="computeDisplayInformationInView:">computeDisplayInformationInView: aView 
	self computeDisplayOffsetsInView: aView.
	self computeModifierDisplayInformationInView: aView.
	self computeSerialNumberDisplayInformationInView: aView</body>

<body package="ChemoJun-Display-Viewer" selector="computeDisplayOffsetFor:">computeDisplayOffsetFor: atomObject 
	atomObject displayOffsetOfSerialNumber 
		ifNil: [atomObject displayOffsetOfSerialNumber: 0 @ 0]</body>

<body package="ChemoJun-Display-Viewer" selector="computeDisplayOffsetFor:fromAtom:toAtom:inView:">computeDisplayOffsetFor: atomObject fromAtom: fromAtom toAtom: toAtom inView: aView 
	atomObject displayOffsetOfSerialNumber ifNil: 
			[atomObject displayOffsetOfSerialNumber: (self 
						computeOffsetOfSerialNumber: atomObject
						fromAtom: fromAtom
						toAtom: toAtom
						inView: aView)].
	atomObject displayOffsetOfModifier ifNil: 
			[atomObject displayOffsetOfModifier: (self 
						computeOffsetOfModifier: atomObject
						fromAtom: fromAtom
						toAtom: toAtom
						inView: aView)]</body>

<body package="ChemoJun-Display-Viewer" selector="computeDisplayOffsetsInView:">computeDisplayOffsetsInView: aView 
	self messageSymbol = #moleculeAsPlane 
		ifTrue: 
			[| aSet fromAtom toAtom |
			aSet := Set new.
			self atomConnectionsDo: 
					[:atomConnection | 
					fromAtom := atomConnection fromAtom.
					toAtom := atomConnection toAtom.
					(Array with: fromAtom with: toAtom) do: 
							[:atomObject | 
							(aSet includes: atomObject) 
								ifFalse: 
									[(self hasModifier: atomObject) 
										ifTrue: 
											[self 
												computeDisplayOffsetFor: atomObject
												fromAtom: fromAtom
												toAtom: toAtom
												inView: aView]
										ifFalse: [self computeDisplayOffsetFor: atomObject].
									aSet add: atomObject]]]]
		ifFalse: 
			[self 
				atomObjectsDo: [:atomObject | self computeDisplayOffsetFor: atomObject]]</body>

<body package="ChemoJun-Display-Viewer" selector="computeModifierDisplayInformationInView:">computeModifierDisplayInformationInView: aView 
	self atomObjectsDo: 
			[:atomObject | 
			| aBox aPoint zValue |
			atomObject displayBooleanOfModifier: false.
			(self modifierImage: atomObject) ifNotNil: 
					[:anImage | 
					aBox := anImage bounds.
					aPoint := self convertModelPointToView3dPoint: atomObject atomicPoint
								in: aView bounds.
					zValue := aPoint z.
					aPoint := (aPoint x @ aPoint y) rounded.
					aBox := aBox align: aBox center with: aPoint.
					aPoint := atomObject displayFocusAtomPointOfModifier.
					aBox := aBox translatedBy: aPoint.
					aPoint := atomObject displayOffsetOfModifier.
					aBox := aBox translatedBy: aPoint.
					atomObject displayBoxOfModifier: aBox.
					atomObject displayOrderOfModifier: zValue.
					atomObject displayBooleanOfModifier: true]]</body>

<body package="ChemoJun-Display-Viewer" selector="computeOffsetOfModifier:fromAtom:toAtom:inView:">computeOffsetOfModifier: atomObject fromAtom: fromAtom toAtom: toAtom inView: aView 
	| anImage |
	anImage := self 
				modifierImage: atomObject
				fromAtom: fromAtom
				toAtom: toAtom
				inView: aView.
	anImage yourself.
	^0 @ 0</body>

<body package="ChemoJun-Display-Viewer" selector="computeOffsetOfSerialNumber:fromAtom:toAtom:inView:">computeOffsetOfSerialNumber: atomObject fromAtom: fromAtom toAtom: toAtom inView: aView 
	| offsetLength anotherAtom fromPoint toPoint offsetPoint |
	offsetLength := self fontSizeOfCharacter // 2 
				+ (self defaultStyleOfSerialNumber lineGrid // 2).
	anotherAtom := fromAtom = atomObject ifTrue: [toAtom] ifFalse: [fromAtom].
	fromPoint := (self convertModelPointToView3dPoint: anotherAtom atomicPoint
				in: aView bounds) as2dPoint.
	toPoint := (self convertModelPointToView3dPoint: atomObject atomicPoint
				in: aView bounds) as2dPoint.
	toPoint y - fromPoint y &gt;= 0 
		ifTrue: [offsetPoint := 0 @ offsetLength]
		ifFalse: [offsetPoint := 0 @ (offsetLength negated - 2)].
	^offsetPoint</body>

<body package="ChemoJun-Display-Viewer" selector="computeSerialNumberDisplayInformationInView:">computeSerialNumberDisplayInformationInView: aView 
	self atomObjectsDo: 
			[:atomObject | 
			atomObject displayBooleanOfSerialNumber: false.
			(self serialNumberComposedText: atomObject) ifNotNil: 
					[:composedText | 
					| aPoint zValue aBox minBox |
					aPoint := self convertModelPointToView3dPoint: atomObject atomicPoint
								in: aView bounds.
					zValue := aPoint z.
					aPoint := (aPoint x @ aPoint y) rounded.
					aBox := composedText bounds.
					minBox := self defaultMinimumBoxOfSerialNumber.
					minBox := minBox align: minBox center with: aBox center.
					aBox area &lt; minBox area ifTrue: [aBox := aBox merge: minBox].
					aBox := aBox align: aBox center with: aPoint.
					atomObject displayOffsetOfSerialNumber 
						ifNil: [atomObject displayOffsetOfSerialNumber: 0 @ 0].
					aPoint := atomObject displayOffsetOfSerialNumber.
					aBox := aBox translatedBy: aPoint.
					atomObject displayBoxOfSerialNumber: aBox.
					atomObject displayOrderOfSerialNumber: zValue.
					atomObject displayBooleanOfSerialNumber: true]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>converting</category>

<body package="ChemoJun-Display-Viewer" selector="asGraph">asGraph
	^self moleculeObject asGraph</body>

<body package="ChemoJun-Display-Viewer" selector="asGrapher">asGrapher
	^self moleculeObject asGrapher</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>defaults</category>

<body package="ChemoJun-Display-Viewer" selector="defaultBaseName">defaultBaseName
	self moleculeObject isNil ifTrue: [^super defaultBaseName].
	self moleculeObject fileName isNil ifTrue: [^super defaultBaseName].
	self moleculeObject is2d 
		ifTrue: 
			[^(Filename splitExtension: self moleculeObject baseName) first , '_' 
				, JunSystem defaultBaseName , '.2D'].
	^self moleculeObject baseName , '_' , JunSystem defaultBaseName</body>

<body package="ChemoJun-Display-Viewer" selector="defaultColorOfSerialNumber">defaultColorOfSerialNumber
	^ColorValue brightness: 0.05</body>

<body package="ChemoJun-Display-Viewer" selector="defaultEyePoint">defaultEyePoint
	| box distance |
	self displayObject isNil ifTrue: [^0 , 0 , 10000].
	^self defaultProjectionTable at: #eyePoint
		ifAbsent: 
			[box := self boundingBox.
			distance := box origin distance: box corner.
			distance := distance * 2.
			^0 , 0 , distance]</body>

<body package="ChemoJun-Display-Viewer" selector="defaultMessageSymbol">defaultMessageSymbol
	^#moleculeAsStick</body>

<body package="ChemoJun-Display-Viewer" selector="defaultMinimumBoxOfSerialNumber">defaultMinimumBoxOfSerialNumber
	^(0 @ 0 extent: 13 @ (self defaultStyleOfSerialNumber lineGrid max: 13)) 
		rounded</body>

<body package="ChemoJun-Display-Viewer" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^self class defaultMoleculeObjectClass</body>

<body package="ChemoJun-Display-Viewer" selector="defaultMolFileReaderClass">defaultMolFileReaderClass
	^self class defaultMolFileReaderClass</body>

<body package="ChemoJun-Display-Viewer" selector="defaultString">defaultString
	^'Molecule' copy</body>

<body package="ChemoJun-Display-Viewer" selector="defaultStyleOfSerialNumber">defaultStyleOfSerialNumber
	^TextAttributes styleNamed: #small ifAbsent: [TextAttributes default]</body>

<body package="ChemoJun-Display-Viewer" selector="defaultUpVector">defaultUpVector
	^self defaultProjectionTable at: #upVector ifAbsent: [0 , 1 , 0]</body>

<body package="ChemoJun-Display-Viewer" selector="defaultWindowLabel">defaultWindowLabel
	^(#chemoJun_Molecular_Viewer &gt;&gt; 'Molecular Viewer') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>displaying</category>

<body package="ChemoJun-Display-Viewer" selector="changedViewBox:">changedViewBox: newBounds 
	super changedViewBox: newBounds.
	self flushModifierAttributes</body>

<body package="ChemoJun-Display-Viewer" selector="displayInformationInView:">displayInformationInView: aView 
	self messageSymbol = #moleculeAsPlane 
		ifTrue: [self displayModifierInView: aView].
	self displaySerialInView: aView</body>

<body package="ChemoJun-Display-Viewer" selector="displayModifierInView:">displayModifierInView: aView 
	| aGraphicsContext aCollection |
	aGraphicsContext := aView graphicsContext.
	aCollection := SortedCollection new: self numberOfAtoms.
	aCollection sortBlock: [:n1 :n2 | n1 &gt;= n2].
	self atomObjectsDo: 
			[:atomObject | 
			atomObject displayBooleanOfModifier 
				ifTrue: [aCollection add: atomObject displayOrderOfModifier -&gt; atomObject]].
	aCollection do: 
			[:anAssociation | 
			| atomObject anImage aBox |
			atomObject := anAssociation value.
			anImage := atomObject displayImageOfModifier.
			aBox := atomObject displayBoxOfModifier.
			self 
				displayImage: anImage
				on: aGraphicsContext
				at: aBox origin].
	self moleculeObject isolatedAtoms do: 
			[:atomObject | 
			| anImage aPoint |
			anImage := (self convertModifierStringToImage: atomObject atomicSymbol
						focusAtomIndex: 1) first.
			aPoint := self convertModelPointToViewPoint: atomObject atomicPoint
						in: aView bounds.
			anImage displayOn: aGraphicsContext at: aPoint - anImage bounds center]</body>

<body package="ChemoJun-Display-Viewer" selector="displaySerialInView:">displaySerialInView: aView 
	| aGraphicsContext aCollection |
	self exceptIndex ifTrue: [^nil].
	aGraphicsContext := aView graphicsContext.
	aCollection := SortedCollection new: self numberOfAtoms.
	aCollection sortBlock: [:n1 :n2 | n1 &gt;= n2].
	self atomObjectsDo: 
			[:atomObject | 
			atomObject displayBooleanOfSerialNumber 
				ifTrue: [aCollection add: atomObject displayOrderOfSerialNumber -&gt; atomObject]].
	aCollection do: 
			[:anAssociation | 
			| atomObject aComposedText aBox |
			atomObject := anAssociation value.
			aComposedText := atomObject displayComposedTextOfSerialNumber.
			aBox := atomObject displayBoxOfSerialNumber.
			self 
				displayComposedText: aComposedText
				on: aGraphicsContext
				at: aBox center
				textColor: self defaultColorOfSerialNumber
				vergeColor: (ColorValue brightness: 0.95)
				alignmentSymbol: #center]</body>

<body package="ChemoJun-Display-Viewer" selector="displaySuperimposeInView:">displaySuperimposeInView: aView 
	aView isNil ifTrue: [^nil].
	aView isOpen ifFalse: [^nil].
	self moleculeObject isNil ifTrue: [^nil].
	self superimposeZoomHeight: self zoomHeight.
	self computeDisplayInformationInView: aView.
	self displayInformationInView: aView</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>enumerating</category>

<body package="ChemoJun-Display-Viewer" selector="atomConnectionsDo:">atomConnectionsDo: aBlock 
	self moleculeObject ifNotNil: [:it | it atomConnectionsDo: aBlock]</body>

<body package="ChemoJun-Display-Viewer" selector="atomObjectsAndIndexesDo:">atomObjectsAndIndexesDo: aBlock 
	self moleculeObject ifNotNil: [:it | it atomObjectsAndIndexesDo: aBlock]</body>

<body package="ChemoJun-Display-Viewer" selector="atomObjectsDo:">atomObjectsDo: aBlock 
	self moleculeObject ifNotNil: [:it | it atomObjectsDo: aBlock]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>flushing</category>

<body package="ChemoJun-Display-Viewer" selector="flushDisplayAttributes">flushDisplayAttributes
	self atomObjectsDo: 
			[:atomObject | 
			| displayKeys |
			displayKeys := atomObject attributeTable keys 
						select: [:displayKey | JunStringUtility stringMatch: displayKey asString and: 'display*'].
			displayKeys 
				do: [:displayKey | atomObject attributeTable removeKey: displayKey]]</body>

<body package="ChemoJun-Display-Viewer" selector="flushDisplayObject">flushDisplayObject
	super flushDisplayObject.
	self flushDisplayAttributes</body>

<body package="ChemoJun-Display-Viewer" selector="flushModifierAttributes">flushModifierAttributes
	self atomObjectsDo: 
			[:atomObject | 
			| displayKeys |
			displayKeys := atomObject attributeTable keys select: 
							[:displayKey | 
							JunStringUtility stringMatch: displayKey asString and: 'display*Modifier'].
			displayKeys 
				do: [:displayKey | atomObject attributeTable removeKey: displayKey].
			atomObject displayOffsetOfSerialNumber: nil]</body>

<body package="ChemoJun-Display-Viewer" selector="flushSerialNumberAttributes">flushSerialNumberAttributes
	self atomObjectsDo: 
			[:atomObject | 
			| displayKeys |
			displayKeys := atomObject attributeTable keys select: 
							[:displayKey | 
							JunStringUtility stringMatch: displayKey asString
								and: 'display*SerialNumber'].
			displayKeys 
				do: [:displayKey | atomObject attributeTable removeKey: displayKey]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>interface opening</category>

<body package="ChemoJun-Display-Viewer" selector="cameraButtonView">cameraButtonView
	| view |
	view := JunButtonView new.
	view model: self cameraButton.
	^view</body>

<body package="ChemoJun-Display-Viewer" selector="postBuildWith:">postBuildWith: aBuilder 
	super postBuildWith: aBuilder.
	self beInvisibleCameraButton</body>

<body package="ChemoJun-Display-Viewer" selector="setWindowLabel">setWindowLabel
	| aWindow aFilename aString |
	aWindow := self getWindow.
	aWindow isNil ifTrue: [^nil].
	aWindow model = self ifFalse: [^nil].
	self moleculeObject isNil 
		ifTrue: [^aWindow label: self defaultWindowLabel].
	self moleculeObject fileName isNil 
		ifTrue: [^aWindow label: self defaultWindowLabel].
	aFilename := self moleculeObject fileName asFilename.
	aString := (Filename splitPath: aFilename asString) last.
	self chemoJunJapanese 
		ifTrue: 
			[(ChemoJunUtility japaneseMolfileName: aFilename) 
				ifNotNil: [:japaneseMolfileName | aString := japaneseMolfileName]].
	aWindow label: self defaultWindowLabel , ' [' , aString , ']'</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>manipulating</category>

<body package="ChemoJun-Display-Viewer" selector="focus:to:">focus: aRectangle1 to: aRectangle2 
	| originalRectangle newRectangle aProjection originalCenter newCenter originalTop originalBottom originalLeft originalRight originalHeight originalWidth newTop newBottom newLeft newRight newHeight newWidth newViewHeight newViewWidth tmpViewHeight newZoomHeight aLine minimumDistance aPoint targetPoint |
	InputState default shiftDown 
		ifTrue: 
			[originalRectangle := aRectangle2.
			newRectangle := aRectangle1]
		ifFalse: 
			[originalRectangle := aRectangle1.
			newRectangle := aRectangle2].
	self displayObject isNil ifTrue: [^self].
	aProjection := self displayProjection.
	originalCenter := aProjection 
				translateTo3dPointFromPoint: (originalRectangle origin 
						+ originalRectangle corner) / 2.0d.
	newCenter := aProjection 
				translateTo3dPointFromPoint: (newRectangle origin + newRectangle corner) 
						/ 2.0d.
	aProjection 
		sightPoint: aProjection sightPoint + (newCenter - originalCenter).
	originalTop := aProjection 
				translateTo3dPointFromPoint: 0 , originalRectangle origin y.
	originalBottom := aProjection 
				translateTo3dPointFromPoint: 0 , originalRectangle corner y.
	originalLeft := aProjection 
				translateTo3dPointFromPoint: originalRectangle origin x , 0.
	originalRight := aProjection 
				translateTo3dPointFromPoint: originalRectangle corner x , 0.
	originalHeight := (originalTop - originalBottom) length.
	originalWidth := (originalLeft - originalRight) length.
	newTop := aProjection 
				translateTo3dPointFromPoint: 0 , newRectangle origin y.
	newBottom := aProjection 
				translateTo3dPointFromPoint: 0 , newRectangle corner y.
	newLeft := aProjection 
				translateTo3dPointFromPoint: newRectangle origin x , 0.
	newRight := aProjection 
				translateTo3dPointFromPoint: newRectangle corner x , 0.
	newHeight := (newTop - newBottom) length.
	newWidth := (newLeft - newRight) length.
	newViewHeight := aProjection regularHeight * newHeight / originalHeight.
	newViewWidth := newViewHeight * newWidth / newHeight.
	originalWidth / originalHeight * newViewHeight &lt; newViewWidth 
		ifTrue: 
			[tmpViewHeight := originalWidth / originalHeight 
						* (newViewHeight / newViewWidth) * newViewHeight.
			newZoomHeight := newViewHeight * (newViewHeight / tmpViewHeight)]
		ifFalse: [newZoomHeight := newViewHeight].
	(originalHeight * 0.01d &lt; newHeight 
		and: [newHeight * 0.01d &lt; originalHeight]) 
			ifTrue: [aProjection zoomHeight: newZoomHeight].
	self moleculeObject notNil 
		ifTrue: 
			[minimumDistance := nil.
			targetPoint := nil.
			aLine := Jun3dLine from: aProjection eyePoint to: aProjection sightPoint.
			self atomObjectsDo: 
					[:each | 
					aPoint := each atomicPoint.
					minimumDistance isNil 
						ifTrue: 
							[minimumDistance := aLine distanceFromPoint: aPoint.
							targetPoint := aPoint]
						ifFalse: 
							[minimumDistance &gt; (aLine distanceFromPoint: aPoint) 
								ifTrue: 
									[minimumDistance := aLine distanceFromPoint: aPoint.
									targetPoint := aPoint]]].
			targetPoint notNil ifTrue: [aProjection sightPoint: targetPoint]].
	self displayProjection: aProjection.
	self changed: #projection</body>

<body package="ChemoJun-Display-Viewer" selector="grab:">grab: deltaPoint 
	self flushModifierAttributes.
	super grab: deltaPoint</body>

<body package="ChemoJun-Display-Viewer" selector="grab:xy:">grab: from2dPoint xy: to2dPoint 
	self flushModifierAttributes.
	super grab: from2dPoint xy: to2dPoint</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>menu accessing</category>

<body package="ChemoJun-Display-Viewer" selector="updateMiscMenuIndication">updateMiscMenuIndication
	| menuItem aMenu |
	super updateMiscMenuIndication.
	menuItem := self menuItemLabeled: 'Misc' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #showInformation ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self moleculeObject isNil 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]]]</body>

<body package="ChemoJun-Display-Viewer" selector="updateViewMenuIndication">updateViewMenuIndication
	| menuItem aMenu |
	super updateViewMenuIndication.
	menuItem := self menuItemLabeled: 'View' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #showMoleculeAsPlane ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsPlane 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsStick ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsStick 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsBallAndStick
						ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsBallAndStick 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsSpaceFill ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsSpaceFill 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #showMoleculeAsStickAndSpaceFill
						ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self messageSymbol = #moleculeAsStickAndSpaceFill 
						ifTrue: [menuItem beOn]
						ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #toggleHydrogen ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self exceptHydrogen ifTrue: [menuItem beOff] ifFalse: [menuItem beOn].
					self messageSymbol = #moleculeAsSpaceFill ifTrue: [menuItem disable]].
			menuItem := aMenu menuItemWithValue: #toggleIndex ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self exceptIndex ifTrue: [menuItem beOff] ifFalse: [menuItem beOn].
					self messageSymbol = #moleculeAsSpaceFill ifTrue: [menuItem disable]].
			menuItem := aMenu menuItemWithValue: #settingIndex ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self exceptIndex ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #lowResolution ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self messageSymbol = #moleculeAsPlane 
						ifTrue: [menuItem disable]
						ifFalse: 
							[menuItem enable.
							self moleculeObject isNil 
								ifTrue: 
									[self defaultResolution = #low 
										ifTrue: [menuItem beOn]
										ifFalse: [menuItem beOff]]
								ifFalse: 
									[self moleculeObject atomResolution = #low 
										ifTrue: [menuItem beOn]
										ifFalse: [menuItem beOff]]]].
			menuItem := aMenu menuItemWithValue: #mediumResolution ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self messageSymbol = #moleculeAsPlane 
						ifTrue: [menuItem disable]
						ifFalse: 
							[menuItem enable.
							self moleculeObject isNil 
								ifTrue: 
									[self defaultResolution = #medium 
										ifTrue: [menuItem beOn]
										ifFalse: [menuItem beOff]]
								ifFalse: 
									[self moleculeObject atomResolution = #medium 
										ifTrue: [menuItem beOn]
										ifFalse: [menuItem beOff]]]].
			menuItem := aMenu menuItemWithValue: #highResolution ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self messageSymbol = #moleculeAsPlane 
						ifTrue: [menuItem disable]
						ifFalse: 
							[menuItem enable.
							self moleculeObject isNil 
								ifTrue: 
									[self defaultResolution = #high 
										ifTrue: [menuItem beOn]
										ifFalse: [menuItem beOff]]
								ifFalse: 
									[self moleculeObject atomResolution = #high 
										ifTrue: [menuItem beOn]
										ifFalse: [menuItem beOff]]]].
			menuItem := aMenu menuItemWithValue: #resetView ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self moleculeObject isNil 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>menu messages</category>

<body package="ChemoJun-Display-Viewer" selector="highResolution">highResolution
	self moleculeObject isNil ifTrue: [^super highResolution].
	self moleculeObject atomResolution = #high ifTrue: [^nil].
	self moleculeObject atomResolution: #high.
	self flushDisplayObject.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="lowResolution">lowResolution
	self moleculeObject isNil ifTrue: [^super lowResolution].
	self moleculeObject atomResolution = #low ifTrue: [^nil].
	self moleculeObject atomResolution: #low.
	self flushDisplayObject.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="mediumResolution">mediumResolution
	self moleculeObject isNil ifTrue: [^super mediumResolution].
	self moleculeObject atomResolution = #medium ifTrue: [^nil].
	self moleculeObject atomResolution: #medium.
	self flushDisplayObject.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="moleculeFromReader:">moleculeFromReader: aReader 
	| chemMolecule cursorAnimator |
	aReader isNil ifTrue: [^nil].
	chemMolecule := self defaultMoleculeObjectClass fromReader: aReader.
	cursorAnimator := JunCursorAnimator clockCursors.
	cursorAnimator tick: 1000.
	cursorAnimator showWhile: 
			[self moleculeObject isNil 
				ifTrue: [chemMolecule atomResolution: self defaultResolution]
				ifFalse: [chemMolecule atomResolution: self moleculeObject atomResolution].
			chemMolecule exceptHydrogen: self exceptHydrogen.
			self moleculeObject: chemMolecule.
			self setWindowLabel.
			self resetView.
			self updateMenuIndication]</body>

<body package="ChemoJun-Display-Viewer" selector="openMolecule">openMolecule
	| aReader |
	aReader := self defaultMolFileReaderClass request.
	aReader isNil ifTrue: [^nil].
	^self moleculeFromReader: aReader</body>

<body package="ChemoJun-Display-Viewer" selector="resetView">resetView
	super resetView.
	self is2d 
		ifTrue: [self zoomHeight: self zoomHeight * self zoomHeightMagnifyingFactor]</body>

<body package="ChemoJun-Display-Viewer" selector="saveAsFile">saveAsFile
	| aWriter |
	self moleculeObject isNil ifTrue: [^nil].
	aWriter := ChemoJunMolFileWriter 
				requestInitialFileName: self defaultBaseName 
						, self moleculeObject extension.
	aWriter ifNil: [^nil].
	self saveFileTo: aWriter fileName.
	self moleculeObject fileName: aWriter fileName.
	self setWindowLabel</body>

<body package="ChemoJun-Display-Viewer" selector="saveFileTo:">saveFileTo: moleculeFilename 
	| aWriter |
	aWriter := ChemoJunMolFileWriter fileName: moleculeFilename.
	aWriter isNil ifTrue: [^nil].
	aWriter moleculeObject: self moleculeObject.
	aWriter write</body>

<body package="ChemoJun-Display-Viewer" selector="showMoleculeAsBallAndStick">showMoleculeAsBallAndStick
	self moleculeObject isNil 
		ifTrue: 
			[self messageSymbol: #moleculeAsBallAndStick.
			self updateViewMenuIndication.
			^nil].
	self messageSymbol = #moleculeAsBallAndStick ifTrue: [^nil].
	self messageSymbol: #moleculeAsBallAndStick.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="showMoleculeAsPlane">showMoleculeAsPlane
	self moleculeObject isNil 
		ifTrue: 
			[self messageSymbol: #moleculeAsPlane.
			self updateViewMenuIndication.
			^nil].
	self messageSymbol = #moleculeAsPlane ifTrue: [^nil].
	self messageSymbol: #moleculeAsPlane.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="showMoleculeAsSpaceFill">showMoleculeAsSpaceFill
	self moleculeObject isNil 
		ifTrue: 
			[self messageSymbol: #moleculeAsSpaceFill.
			self exceptIndex: true.
			self updateViewMenuIndication.
			^nil].
	self messageSymbol = #moleculeAsSpaceFill ifTrue: [^nil].
	self messageSymbol: #moleculeAsSpaceFill.
	self exceptIndex: true.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="showMoleculeAsStick">showMoleculeAsStick
	self moleculeObject isNil
		ifTrue: 
			[self messageSymbol: #moleculeAsStick.
			self updateViewMenuIndication.
			^nil].
	self messageSymbol = #moleculeAsStick ifTrue: [^nil].
	self messageSymbol: #moleculeAsStick.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="showMoleculeAsStickAndSpaceFill">showMoleculeAsStickAndSpaceFill
	self moleculeObject isNil
		ifTrue: 
			[self messageSymbol: #moleculeAsStickAndSpaceFill.
			self updateViewMenuIndication.
			^nil].
	self messageSymbol = #moleculeAsStickAndSpaceFill ifTrue: [^nil].
	self messageSymbol: #moleculeAsStickAndSpaceFill.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="toggleHydrogen">toggleHydrogen
	self messageSymbol = #moleculeAsSpaceFill ifTrue: [^nil].
	self exceptHydrogen: self exceptHydrogen not.
	self flushDisplayObject.
	self changed: #object.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Display-Viewer" selector="toggleIndex">toggleIndex
	self messageSymbol = #moleculeAsSpaceFill ifTrue: [^nil].
	self exceptIndex: self exceptIndex not.
	self changed: #object.
	self updateViewMenuIndication</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>preferences</category>

<body package="ChemoJun-Display-Viewer" selector="superimposeZoomHeight">superimposeZoomHeight
	^self preferenceTable at: #superimposeZoomHeight ifAbsentPut: [nil]</body>

<body package="ChemoJun-Display-Viewer" selector="superimposeZoomHeight:">superimposeZoomHeight: zoomHeight 
	self 
		assert: [self superimposeZoomHeight]
		do: [self preferenceTable at: #superimposeZoomHeight put: zoomHeight]
		ensure: 
			[:oldValue | 
			oldValue = zoomHeight 
				ifFalse: 
					[self
						flushSerialNumberAttributes;
						flushModifierAttributes]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>projection</category>

<body package="ChemoJun-Display-Viewer" selector="zoomHeightMagnifyingFactor">zoomHeightMagnifyingFactor
	self displayObject ifNotNil: 
			[:body | 
			| extent maximum length |
			extent := body boundingBox extent.
			maximum := extent x max: (extent y max: extent z).
			length := self averageLengthOfConnections.
			maximum &lt; (length * 1) ifTrue: [^2.5].
			maximum &lt; (length * 2) ifTrue: [^2.0].
			maximum &lt; (length * 3) ifTrue: [^1.5]].
	^1.2</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>testing</category>

<body package="ChemoJun-Display-Viewer" selector="hasModifier:">hasModifier: atomObject 
	(self moleculeObject isMethyl: atomObject) ifTrue: [^true].
	(self moleculeObject isHydroxyl: atomObject) ifTrue: [^true].
	(self moleculeObject isCarbonWithTwoDoubleBonds: atomObject) ifTrue: [^true].
	^atomObject isCarbon not and: 
			[atomObject isHydrogen not 
				or: [atomObject isHydrogen and: [self exceptHydrogen not]]]</body>

<body package="ChemoJun-Display-Viewer" selector="is2d">is2d
	^self moleculeObject ifNil: [super is2d] ifNotNil: [:it | it is2d]</body>

<body package="ChemoJun-Display-Viewer" selector="is3d">is3d
	^self moleculeObject ifNil: [super is3d] ifNotNil: [:it | it is3d]</body>

<body package="ChemoJun-Display-Viewer" selector="isMoleculeViewer">isMoleculeViewer
	^true</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>updating</category>

<body package="ChemoJun-Display-Viewer" selector="updateStringHolder:">updateStringHolder: aPoint 
	| x y z |
	aPoint isNil ifTrue: [^self stringHolder value: self defaultString].
	x := aPoint x asFloat.
	y := aPoint y asFloat.
	z := aPoint z asFloat.
	self stringHolder 
		value: x printString , ', ' , y printString , ', ' , z printString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>wheel actions</category>

<body package="ChemoJun-Display-Viewer" selector="wheelActionInTopCenterBox:">wheelActionInTopCenterBox: wheelUpBoolean 
	self flushModifierAttributes.
	super wheelActionInTopCenterBox: wheelUpBoolean</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeViewer</class-id> <category>private</category>

<body package="ChemoJun-Display-Viewer" selector="character:size:">character: aCharacter size: fontSize 
	^ChemoJunHelvetica character: aCharacter size: fontSize</body>

<body package="ChemoJun-Display-Viewer" selector="cloneViewer">cloneViewer
	| aViewer |
	aViewer := super cloneViewer.
	aViewer moleculeObject: self moleculeObject copy.
	aViewer messageSymbol: self messageSymbol.
	^aViewer</body>

<body package="ChemoJun-Display-Viewer" selector="convertModifierStringToImage:focusAtomIndex:">convertModifierStringToImage: aString focusAtomIndex: anIndex 
	| lineGrid subscriptGrid subscriptDelta maxHeight focusBox aPoint anImage marginX imageBox focusPoint |
	lineGrid := (self character: $A size: self fontSizeOfCharacter) height.
	subscriptGrid := (self character: $A size: self fontSizeOfSubscript) 
				height.
	subscriptDelta := lineGrid - subscriptGrid.
	self fontSizeOfSubscript &gt; 10 
		ifTrue: [subscriptDelta := subscriptDelta max: 5]
		ifFalse: [subscriptDelta := subscriptDelta max: 3].
	maxHeight := lineGrid + (subscriptGrid + subscriptDelta - lineGrid).
	focusBox := nil.
	self 
		assert: [Pixmap extent: (lineGrid * aString size * 2) @ maxHeight]
		do: 
			[:aPixmap | 
			| graphicsContext |
			graphicsContext := aPixmap graphicsContext.
			graphicsContext paint: ColorValue white.
			graphicsContext displayRectangle: aPixmap bounds.
			graphicsContext paint: ColorValue black.
			aPoint := Point zero.
			aString with: (1 to: aString size)
				do: 
					[:aCharacter :characterIndex | 
					| oneImage |
					aCharacter isDigit 
						ifTrue: 
							[oneImage := self character: aCharacter size: self fontSizeOfSubscript.
							oneImage displayOn: graphicsContext at: aPoint + (0 @ subscriptDelta)]
						ifFalse: 
							[oneImage := self character: aCharacter size: self fontSizeOfCharacter.
							oneImage displayOn: graphicsContext at: aPoint].
					characterIndex = anIndex 
						ifTrue: 
							[focusBox := oneImage bounds align: oneImage bounds origin with: aPoint].
					aPoint := aPoint + (oneImage bounds width @ 0)].
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	marginX := 2.
	self 
		assert: [Pixmap extent: (aPoint x + (marginX * 2)) @ maxHeight]
		do: 
			[:aPixmap | 
			| graphicsContext |
			graphicsContext := aPixmap graphicsContext.
			graphicsContext paint: ColorValue white.
			graphicsContext displayRectangle: aPixmap bounds.
			anImage displayOn: graphicsContext at: marginX @ 0.
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	imageBox := anImage bounds insetBy: marginX @ 0.
	focusBox isNil 
		ifTrue: [focusPoint := 0 @ 0]
		ifFalse: 
			[focusPoint := (imageBox align: imageBox center with: focusBox center) 
						origin negated].
	^Array with: anImage with: focusPoint</body>

<body package="ChemoJun-Display-Viewer" selector="fontSizeOfCharacter">fontSizeOfCharacter
	| length height ratio |
	length := self averageLengthOfConnections.
	(height := self superimposeZoomHeight) ifNil: [^12].
	ratio := length / height.
	ratio &gt; 0.5 ifTrue: [^36].
	ratio &gt; 0.4 ifTrue: [^24].
	ratio &gt; 0.3 ifTrue: [^18].
	ratio &gt; 0.2 ifTrue: [^14].
	ratio &gt; 0.1 ifTrue: [^12].
	ratio &gt; 0.05 ifTrue: [^10].
	ratio &gt; 0.25 ifTrue: [^9].
	^7</body>

<body package="ChemoJun-Display-Viewer" selector="fontSizeOfSubscript">fontSizeOfSubscript
	| length height ratio |
	length := self averageLengthOfConnections.
	(height := self superimposeZoomHeight) ifNil: [^9].
	ratio := length / height.
	ratio &gt; 0.5 ifTrue: [^24].
	ratio &gt; 0.4 ifTrue: [^18].
	ratio &gt; 0.3 ifTrue: [^12].
	ratio &gt; 0.2 ifTrue: [^9].
	ratio &gt; 0.1 ifTrue: [^9].
	ratio &gt; 0.05 ifTrue: [^9].
	ratio &gt; 0.25 ifTrue: [^7].
	^5</body>

<body package="ChemoJun-Display-Viewer" selector="setIndexExpression:setIndexExpressionBlock:">setIndexExpression: aString setIndexExpressionBlock: aBlock 
	indexExpression := aString.
	indexExpressionBlock := aBlock</body>

<body package="ChemoJun-Display-Viewer" selector="setMoleculeObject:">setMoleculeObject: aMoleculeObject 
	moleculeObject := aMoleculeObject</body>
</methods>


</st-source>
