<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76985 "21:23:05"))'</do-it>



<class>
<name>ChemoJunViewerCatalogElement</name>
<environment>ChemoJun</environment>
<super>Jun.JunAbstractObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>moleculeFilename moleculeObject preferenceTable </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Catalog-Viewer</category>
<attributes>
<package>ChemoJun-Catalog-Viewer</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement class</class-id> <category>instance creation</category>

<body package="ChemoJun-Catalog-Viewer" selector="filename:">filename: aFilename 
	^(self new)
		filename: aFilename;
		yourself</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeObject:">moleculeObject: aMoleculeObject 
	^(self new)
		moleculeObject: aMoleculeObject;
		yourself</body>

<body package="ChemoJun-Catalog-Viewer" selector="new">new
	^(super new)
		initialize;
		yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement class</class-id> <category>copyright</category>

<body package="ChemoJun-Catalog-Viewer" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Catalog-Viewer" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Catalog-Viewer" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement class</class-id> <category>defaults</category>

<body package="ChemoJun-Catalog-Viewer" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^ChemoJunMoleculeObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement class</class-id> <category>examples</category>

<body package="ChemoJun-Catalog-Viewer" selector="example1">example1
	"ChemoJunViewerCatalogElement example1."

	| moleculeObject catalogElement catalogViewer |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject ifNil: [^nil].
	catalogElement := ChemoJunViewerCatalogElement 
				moleculeObject: moleculeObject.
	catalogElement exceptIndex: false.
	Transcript
		clear;
		show: catalogElement toLispList saveString.
	catalogViewer := ChemoJunViewerCatalogViewer new.
	catalogElement applyPreferencesTo: catalogViewer.
	catalogViewer open.
	^catalogElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="example2">example2
	"ChemoJunViewerCatalogElement example2."

	| moleculeObject catalogElement |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject ifNil: [^nil].
	catalogElement := ChemoJunViewerCatalogElement 
				moleculeObject: moleculeObject.
	catalogElement := catalogElement class 
				fromLispList: catalogElement toLispList.
	Transcript
		clear;
		show: catalogElement toLispList saveString.
	^catalogElement</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement class</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Viewer" selector="fromLispList:for:">fromLispList: aList for: anElement 
	| aTable |
	aTable := self tableFromLispList: aList tail.
	self moleculeObjectFromTable: aTable for: anElement.
	self preferenceTableFromTable: aTable for: anElement.
	^anElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeObjectFromTable:for:">moleculeObjectFromTable: aTable for: aCatalog 
	| aString |
	aString := aTable at: #moleculeObject ifAbsent: [^aCatalog].
	aCatalog 
		moleculeObject: (self defaultMoleculeObjectClass fromString: aString).
	^aCatalog</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTableFromTable:for:">preferenceTableFromTable: aTable for: aCatalog 
	| aList preferenceTable |
	aList := aTable at: #preferenceTable ifAbsent: [^aCatalog].
	preferenceTable := JunAttributeTable fromLispList: aList.
	aCatalog preferenceTable: preferenceTable.
	^aCatalog</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunViewerCatalogElement</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement</class-id> <category>initialize-release</category>

<body package="ChemoJun-Catalog-Viewer" selector="initialize">initialize
	moleculeFilename := nil.
	moleculeObject := nil.
	preferenceTable := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement</class-id> <category>accessing</category>

<body package="ChemoJun-Catalog-Viewer" selector="baseNameString">baseNameString
	^(Filename 
		splitExtension: (Filename 
				splitPath: (self filename ifNil: [String new] ifNotNil: [:it | it asString])) 
					last asString) 
			first asString</body>

<body package="ChemoJun-Catalog-Viewer" selector="filename">filename
	^moleculeFilename</body>

<body package="ChemoJun-Catalog-Viewer" selector="filename:">filename: aFilename 
	aFilename ifNil: [^nil].
	aFilename asFilename exists ifFalse: [^nil].
	moleculeFilename := aFilename asString.
	moleculeObject := self class defaultMoleculeObjectClass 
				fileName: aFilename asFilename</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeObject">moleculeObject
	^moleculeObject</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeObject:">moleculeObject: aMoleculeObject 
	moleculeObject := aMoleculeObject.
	moleculeObject fileName ifNil: 
			[moleculeObject fileNameFromHeader ifNotNil: 
					[:aFilename | 
					moleculeFilename := aFilename asString.
					moleculeObject fileName: moleculeFilename]]
		ifNotNil: [:aFilename | moleculeFilename := aFilename asString]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeFilenameToLispList">moleculeFilenameToLispList
	| alist |
	alist := self lispCons.
	alist head: #moleculeFilename.
	alist tail: self filename asString.
	^alist</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeObjectToLispList">moleculeObjectToLispList
	| alist |
	alist := self lispCons.
	alist head: #moleculeObject.
	alist tail: self moleculeObject asString.
	^alist</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTableToLispList">preferenceTableToLispList
	| alist |
	alist := self lispCons.
	alist head: #preferenceTable.
	alist tail: self preferenceTable toLispList.
	^alist</body>

<body package="ChemoJun-Catalog-Viewer" selector="toLispList">toLispList
	| aList |
	aList := self lispCons.
	aList head: self class name.
	self moleculeObject ifNotNil: [aList add: self moleculeObjectToLispList].
	self preferenceTable isEmpty 
		ifFalse: [aList add: self preferenceTableToLispList].
	^aList</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement</class-id> <category>preferences</category>

<body package="ChemoJun-Catalog-Viewer" selector="applyPreferencesFrom:">applyPreferencesFrom: catalogViewer 
	catalogViewer moleculeObject ifNil: [^self].
	self moleculePresentation: catalogViewer messageSymbol.
	self exceptHydrogen: catalogViewer exceptHydrogen.
	self exceptIndex: catalogViewer exceptIndex.
	self atomResolution: catalogViewer moleculeObject atomResolution.
	self serialNumberSetting: catalogViewer serialNumberSetting setting.
	self projectionTable: catalogViewer projectionTable</body>

<body package="ChemoJun-Catalog-Viewer" selector="applyPreferencesTo:">applyPreferencesTo: catalogViewer 
	self moleculeObject atomResolution: self atomResolution.
	catalogViewer setMoleculeObject: self moleculeObject.
	catalogViewer messageSymbol: self moleculePresentation.
	catalogViewer exceptHydrogen: self exceptHydrogen.
	catalogViewer exceptIndex: self exceptIndex.
	self serialNumberSetting 
		ifNil: [catalogViewer serialNumberSetting setting]
		ifNotNil: 
			[:setting | 
			catalogViewer 
				serialNumberSetting: (ChemoJunSerialNumberSetting setting: setting)].
	self projectionTable ifNil: [catalogViewer resetView]
		ifNotNil: [:projectionTable | catalogViewer setProjectionTable: projectionTable]</body>

<body package="ChemoJun-Catalog-Viewer" selector="atomResolution">atomResolution
	^self preferenceTable at: #atomResolution ifAbsentPut: [#medium]</body>

<body package="ChemoJun-Catalog-Viewer" selector="atomResolution:">atomResolution: aSymbol 
	self preferenceTable at: #atomResolution put: aSymbol</body>

<body package="ChemoJun-Catalog-Viewer" selector="exceptHydrogen">exceptHydrogen
	^self preferenceTable at: #exceptHydrogen ifAbsentPut: [false]</body>

<body package="ChemoJun-Catalog-Viewer" selector="exceptHydrogen:">exceptHydrogen: aBoolean 
	self preferenceTable at: #exceptHydrogen put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Viewer" selector="exceptIndex">exceptIndex
	^self preferenceTable at: #exceptIndex ifAbsentPut: [true]</body>

<body package="ChemoJun-Catalog-Viewer" selector="exceptIndex:">exceptIndex: aBoolean 
	self preferenceTable at: #exceptIndex put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculePresentation">moleculePresentation
	^self preferenceTable at: #moleculePresentation
		ifAbsentPut: 
			[self is2d ifTrue: [#moleculeAsPlane] ifFalse: [#moleculeAsBallAndStick]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculePresentation:">moleculePresentation: messageSymbol 
	self preferenceTable at: #moleculePresentation put: messageSymbol</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTable">preferenceTable
	preferenceTable ifNil: [preferenceTable := JunAttributeTable new].
	^preferenceTable</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTable:">preferenceTable: attributeTable 
	preferenceTable := attributeTable</body>

<body package="ChemoJun-Catalog-Viewer" selector="projectionTable">projectionTable
	^self preferenceTable at: #projectionTable ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Viewer" selector="projectionTable:">projectionTable: aDictionary 
	self preferenceTable at: #projectionTable put: aDictionary</body>

<body package="ChemoJun-Catalog-Viewer" selector="serialNumberSetting">serialNumberSetting
	^self preferenceTable at: #serialNumberSetting ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Viewer" selector="serialNumberSetting:">serialNumberSetting: settingCollection 
	self preferenceTable at: #serialNumberSetting put: settingCollection</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement</class-id> <category>printing</category>

<body package="ChemoJun-Catalog-Viewer" selector="printOn:">printOn: aStream 
	aStream nextPutAll: 'CatalogElement('.
	self baseNameString printOn: aStream.
	aStream nextPutAll: ')'</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalogElement</class-id> <category>testing</category>

<body package="ChemoJun-Catalog-Viewer" selector="is2d">is2d
	^self filename ifNil: [false]
		ifNotNil: 
			[:it | 
			| tailName |
			tailName := (Filename splitPath: it asString) last asString asLowercase.
			(JunStringUtility stringMatch: tailName and: '*2d.mol') yourself]</body>

<body package="ChemoJun-Catalog-Viewer" selector="is3d">is3d
	^self is2d not</body>

<body package="ChemoJun-Catalog-Viewer" selector="isVoid">isVoid
	^false</body>
</methods>


</st-source>
